

/*
 cc -g -c ../as/asagent.c
*/

#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <signal.h>


#include "../s_tools/smem.h"
#include "../s_tools/sregex.h"
#include "../s_tools/sfile.h"
#include "../s_tools/stcp.h"
#include "../s_tools/sconn.h"
#include "../s_tools/stunnel.h"
#include "../s_tools/saccess.h"

#include "../as/asqueue.h"
#include "../as/asinput.h"
#include "../as/asprog.h"
#include "../as/asevent.h"
#include "../as/asview.h"
#include "../as/asvmsg.h"
#include "../as/asagent.h"


int Asagent_interpreter(),Asagent_eval(),Asagent_determine_current();
int Asagent_cursor_advance(),Asagent_seems_known();

/* -------------------------------- AsagenT ------------------------------ */


int Asagent_new(agent,progname,input_type,flag)
struct AsagenT **agent;
char *progname;
int input_type;
int flag;
{
 struct AsagenT *m;
 struct AsvieW *view= NULL;
 char *cpt,line[SfileadrL];
 int i,ret;

 *agent= m= TSOB_FELD(struct AsagenT,1);
 if(m==NULL)
   return(-1);
 strcpy(m->progname,progname);
 m->app= (char *) m;
 m->App_interpreter= Asagent_interpreter;
 m->App_eval= Asagent_eval;
 m->App_determine_current= Asagent_determine_current;
 m->App_cursor_advance= Asagent_cursor_advance;
 m->App_seems_known= Asagent_seems_known;
 m->service_mode= 0;
 m->data_mode= 0;
 m->client_sconn= NULL;
 m->server_crucial= 0;      
 m->preclient_disable_internal= 0;
 m->loop_return_on_idle= 0;
 m->encapsulate_views;
 m->input_fd= -2;
 m->override_event_fd= 0;
 m->request_mode= 0;
 m->current_users= NULL;
 m->markstack= NULL;
 m->notified_mark_id= NULL;
 m->notified_mark_fd= -1;
 m->notified_reply_id= NULL;
 m->remote_idx= -1;
 m->remote_count= 0;
 m->remote_adr= NULL;
 m->silent_end= 0;
 m->end_on_flag= 0;
 m->end_on_timeout= 0;
 m->end_on_mark= NULL;
 m->end_on_idle= 0;
 m->recursion_level= 0;
 m->recursion_max= 1000;
 m->start_dir[0]= 0;
 m->arguments_to_queue= 0;
 m->permission_check= 1;
 m->access= NULL;
 m->queue= NULL;
 m->event= NULL;
 for(i=0;i<2;i++) m->stdout_pipe[i]= m->stderr_pipe[i]= -1;
 m->preserve_orphan_events= 0;
 m->view_prototype= NULL;
 m->views= NULL;
 m->view_counter= 0;
 m->ask_counter= 0;
 m->disable_internal= 0;
 m->internal_current_view= NULL;
 m->repair_icv= 0;
 m->repair_icv_idx= -1;
 m->look_for_doubles= 1;
 m->doubles_shown= 0;
 m->maindir= NULL;
 m->trashdir= NULL;
 m->keep_views= 0;
 m->no_keep_views_when_idle= 0;
 m->deferred_rm_jobs= NULL;
 m->viewmsg= NULL;
 m->smem_stderr= 0;

 cpt= getcwd(m->start_dir,sizeof(m->start_dir));
 if(cpt==NULL){
   sprintf(line,"Error %ld on determining working directory :\n%s",
                errno,strerror(errno));
   goto failed;
 }
 ret= Lstring_new(&(m->current_users),"dummy",NULL,0);
 if(ret<=0)
   goto failed;
 ret= Lstring_new(&(m->markstack),"dummy",NULL,0);
 if(ret<=0)
   goto failed;
 ret= Asagent_default_access(m,0);
 if(ret<=0)
   goto failed;
 ret= Asqueue_new(&(m->queue),m,input_type,"",0);
 if(ret<=0)
   goto failed;
 if(pipe(m->stdout_pipe)==-1)
   goto failed;
 ret= Asqueue_new_inconn(m->queue,3|(1<<12),NULL,m->stdout_pipe[0],-1,0);
 if(ret<=0)
   goto failed;
 if(pipe(m->stderr_pipe)==-1)
   goto failed;
 ret= Asqueue_new_inconn(m->queue,4|(1<<12),NULL,m->stderr_pipe[0],-1,0);
 if(ret<=0)
   goto failed;
 ret= Asviewproto_new(&(m->view_prototype),Asagent_viewer_cmD,0);
 if(ret<=0)
   goto failed;
 ret= Asview_new(&view,m,
                  "internal_current_view","child",m->view_prototype,0,0);
 if(ret<=0)
   goto failed;
 m->internal_current_view= view;
 ret= Asview_add_subscr(view,"current_file","address",0);
 if(ret<=0)
   goto failed;
 Asagent_add_view(m,view,0);
 view= NULL;
 ret= Asview_new(&view,m,
                  "internal_double_view","child",m->view_prototype,1,0);
 if(ret<=0)
   goto failed;
 ret= Asview_add_subscr(view,"double_files","address",0);
 if(ret<=0)
   goto failed;
 Asagent_add_view(m,view,0);
 if(m->maindir==NULL){
   ret= Sregex_string(&(m->maindir),".",0);
   if(ret<=0)
     goto failed;
 }
 if(m->trashdir==NULL){
   ret= Sregex_string(&(m->trashdir),"trashdir",0);
   if(ret<=0)
     goto failed;
 }
 ret= Asrm_new(&(m->deferred_rm_jobs),Sfile_microtime(0)+1.0e99,"",0);
 if(ret<=0)
   goto failed;
 return(1);
failed:;
 Asagent_destroy(agent,0);
 return(ret);
}


int Asagent_destroy(agent,flag)
struct AsagenT **agent;
int flag;
{
 struct AsvieW *view,*prev,*next;
 int i;

 if(*agent==NULL)
   return(0);
 Sconn_destroy(&((*agent)->client_sconn),0);
 Lstring_destroy_all(&((*agent)->current_users),0);
 Lstring_destroy_all(&((*agent)->markstack),0);
 Sregex_string(&((*agent)->notified_mark_id),NULL,0);
 Sregex_string(&((*agent)->notified_reply_id),NULL,0);
 Sregex_string(&((*agent)->end_on_mark),NULL,0);
 Sregex_string(&((*agent)->remote_adr),NULL,0);
 Saccess_destroy(&((*agent)->access),0);
 Asqueue_destroy(&((*agent)->queue),0);
 for(i=0;i<2;i++){
   if((*agent)->stdout_pipe[i]>=3) {
     close((*agent)->stdout_pipe[i]);
     (*agent)->stdout_pipe[i]= -1;
   }
   if((*agent)->stderr_pipe[i]>=3) {
     close((*agent)->stderr_pipe[i]);
     (*agent)->stderr_pipe[i]= -1;
   }
 }
 Asevent_destroy(&((*agent)->event),0);
 Asviewproto_destroy(&((*agent)->view_prototype),0);
 view= (*agent)->views;
 while(view!=NULL){
   Asview_get_links(view,&prev,&next,0);
   Asview_destroy(&view,0);
   view= next;
 }
 Sregex_string(&((*agent)->maindir),NULL,0);
 Sregex_string(&((*agent)->trashdir),NULL,0);
 Asviewmsg_destroy(&((*agent)->viewmsg),0);
 Asrm_process_all((*agent)->deferred_rm_jobs,1);

 Smem_freE((char *) *agent);
 *agent= NULL;
 return(1);
}


int Asagent_default_access(agent,flag)
struct AsagenT *agent;
int flag;
{
 int ret;
 struct AsagenT *m;
 char keydir[SfileadrL];

 m= agent;
 ret= Saccess_new(&(m->access),0);
 if(ret<=0)
   goto ex;
 ret= Saccess_append(m->access,"connection","all","tunnel","refuse",0);
 if(ret<=0)
   goto ex;
 ret= Saccess_append(m->access,"connection","all","controller","off",0);
 if(ret<=0)
   goto ex;
 ret= Saccess_append(m->access,"connection","tcp","tunnel","allow",0);
 if(ret<=0)
   goto ex;
 ret= Saccess_append(m->access,"connection","internal","controller","on",0);
 if(ret<=0)
   goto ex;
 ret= Sfile_home_adr("tnl_keydir",keydir,0);
 if(ret<=0)
   goto ex;
 ret= Saccess_append(m->access,"connection","all","keydirectory",keydir,0);
 if(ret<=0)
   goto ex;
/*
 ret= Saccess_append(m->access,"permission","all","user","deny",0);
 if(ret<=0)
   goto ex;
*/
 ret= 1;
ex:;
 return(ret);
}


int Asagent_set_trashdir(agent,dir,flag)
struct AsagenT *agent;
char *dir;
int flag;
/*
 bit0= append
*/
{
 int ret;
 if(dir==NULL)
   ret= Sregex_string(&(agent->trashdir),"",flag&1);
 else
   ret= Sregex_string(&(agent->trashdir),dir,flag&1);
 return(ret);
}


int Asagent_set_maindir(agent,dir,flag)
struct AsagenT *agent;
char *dir;
int flag;
/*
 bit0= append
*/
{
 int ret;
 if(dir==NULL)
   ret= Sregex_string(&(agent->maindir),"",flag&1);
 else
   ret= Sregex_string(&(agent->maindir),dir,flag&1);
 return(ret);
}


int Asagent_get_maindir(agent,dir,flag)
struct AsagenT *agent;
char **dir;
int flag;
{
 if(Sregex_string(dir,agent->maindir,0)<=0)
   return(-1);
 return(1);
}


int Asagent_get_trashdir(agent,dir,flag)
struct AsagenT *agent;
char **dir;
int flag;
{
 if(Sregex_string(dir,agent->trashdir,0)<=0)
   return(-1);
 return(1);
}


int Asagent_get_access(agent,access,flag)
struct AsagenT *agent;
struct SaccesS **access;
int flag;
{
 *access= NULL;
 if(agent==NULL)
   return(0);
 *access= agent->access;
 if(*access==NULL)
   return(0);
 return(1);
}


int Asagent_get_event_cmd(agent,cmd,flag)
struct AsagenT *agent;
char **cmd;
int flag;
{
 int ret;

 ret= Asevent_get_cmd(agent->event,cmd,0);
 return(ret);
}


int Asagent_get_event_connection(agent,flag)
struct AsagenT *agent;
int flag;
{
 if(agent->override_event_fd)
   return(agent->input_fd);
 if(agent->event==NULL)
   return(-2);
 return(agent->event->connection);
}


int Asagent_set_event_connection(agent,fd,flag)
struct AsagenT *agent;
int fd;
int flag;
/*
 bit0= remove override
*/
{
 if(flag&1) {
   agent->override_event_fd= 0;
   agent->input_fd= Asagent_get_event_connection(agent,0);
 } else {
   agent->override_event_fd= 1;
   agent->input_fd= fd;
 }
 return(1);
}


int Asagent_get_viewmsg(agent,msg,flag)
struct AsagenT *agent;
struct AsviewmsG **msg;
int flag;
{
 *msg= NULL;
 if(agent==NULL)
   return(0);
 *msg= agent->viewmsg;
 if(*msg==NULL)
   return(0);
 return(1);
}


int Asagent_get_service_mode(agent,flag)
struct AsagenT *agent;
int flag;
{
 return(agent->service_mode);
}


int Asagent_set_arguments_to_queue(agent,value,flag)
struct AsagenT *agent;
int value;
int flag;
{
 agent->arguments_to_queue= value;
 return(1);
}


int Asagent_set_silent_end(agent,value,flag)
struct AsagenT *agent;
int value;
int flag;
{
 agent->silent_end= value;
 return(1);
}


int Asagent_set_server_crucial(agent,value,flag)
struct AsagenT *agent;
int value;
int flag;
{
 agent->server_crucial= value;
 return(1);
}


int Asagent_get_silent_end(agent,flag)
struct AsagenT *agent;
int flag;
{
 return(agent->silent_end);
}


int Asagent_attach_app(agent,app, App_interpreter,App_eval,
                                   App_determine_current,App_cursor_advance,
                                   App_seems_known, flag)
struct AsagenT *agent;
char *app;
int (*App_interpreter) ();
int (*App_eval) ();
int (*App_determine_current) ();
int (*App_cursor_advance) ();
int (*App_seems_known) ();
int flag;
{
 agent->app= app;
 if(App_interpreter==NULL)
   agent->App_interpreter= Asagent_interpreter;
 else
   agent->App_interpreter= App_interpreter;
 if(App_eval==NULL)
   agent->App_eval= Asagent_eval;
 else
   agent->App_eval= App_eval;
 if(App_determine_current==NULL)
   agent->App_determine_current= Asagent_determine_current;
 else
   agent->App_determine_current= App_determine_current;
 if(App_cursor_advance==NULL)
   agent->App_cursor_advance= Asagent_cursor_advance;
 else
   agent->App_cursor_advance= App_cursor_advance;
 if(App_seems_known==NULL)
   agent->App_seems_known= Asagent_seems_known;
 else
   agent->App_seems_known= App_seems_known;
 return(1);
}


int Asagent_reset_input_source(agent,flag)
struct AsagenT *agent;
int flag;
{
 agent->input_fd= -2;
 agent->override_event_fd= 0;
 agent->request_mode= 0;
 while(agent->current_users->next!=NULL)
   Lstring_destroy(&(agent->current_users->next),1);
 return(1);
}


int Asagent_dummy_event(agent,cmd,connection,username,flag)
struct AsagenT *agent;
char *cmd;
int connection;
char *username;
int flag;
{
 int ret;

 Asevent_destroy(&(agent->event),0);
 ret= Asevent_new(&(agent->event),cmd,connection,username,0);
 if(ret<=0)
   return(ret);
 return(1);
}


int Asagent_event_is_pending(agent,flag)
struct AsagenT *agent;
int flag;
/*
 bit0= do not update the queue before testing
*/
{
 int ret;

 ret= Asqueue_event_is_pending(agent->queue,flag&1);
 return(ret);
}


int Asagent_publish_tcpadr(agent,fileadr,type,flag)
struct AsagenT *agent;
char *fileadr;
int type;
int flag;
/*
 bit0= only revoke current publication (same happens if fileadr==NULL)
*/
{
 int ret=0;
 struct StcpserV *serv;
 
 ret= Asqueue_get_tcpserv(agent->queue,type,&serv,0);
 if(ret<=0) 
   return(ret);
 if(serv==NULL) {
   if(flag&1)
     return(1);
   Asagent_stderr(agent,"No active TCP service of desired type found",1);
   return(0);
 }
 ret= Stcpserv_publish_adress(serv,fileadr,flag&1);
 return(ret);
}


int Asagent_determine_current(agent,adrpt,idx,count,flag)
struct AsagenT *agent;
char **adrpt;
int *idx;
int *count;
int flag;
{
 int ret;

 if(agent->service_mode==1) {
   *adrpt= agent->remote_adr;
   *idx= agent->remote_idx;
   *count= agent->remote_count;
   if(*idx<0)
     return(2);
   return(1);
 }

 if(agent->App_determine_current == Asagent_determine_current) 
   /* this is only a dummy. attach the real thing via Asagent_attach_app */
   goto no_files;
 ret= agent->App_determine_current(agent->app,adrpt,idx,count,flag);
 if(ret==2) 
   goto no_files;
 return(ret);
no_files:;
 *idx= -1;
 *count= 0;
 *adrpt= "";
 return(2);
}


int Asagent_cursor_advance(agent,step,flag)
struct AsagenT *agent;
int *step;
int flag;
/*
 bit0= *step is the absolute index
 bit1= use *step for setting rather than for getting cursor movement
*/
{
 int ret;

 if(agent->App_cursor_advance == Asagent_cursor_advance) {
   /* this is only a dummy. attach the real thing via Asagent_attach_app */
   *step= 0;
   return(1);
 }
 ret= agent->App_cursor_advance(agent->app,step,flag);
 return(ret);
}


int Asagent_add_rm_job(agent,deadline,adr,flag)
struct AsagenT *agent;
double deadline;
char *adr;
int flag;
{
 int ret;

 ret= Asrm_add_after(agent->deferred_rm_jobs,deadline,adr,0);
 return(ret);
}


int Asagent_add_view(agent,view,flag)
struct AsagenT *agent;
struct AsvieW *view;
int flag;
{
 struct AsvieW *current,*prev= NULL,*next= NULL;

 current=  agent->views;
 while(current!=NULL) {
   Asview_get_links(current,&prev,&next,0);
   if(next==NULL)
 break;
   current= next;
 }
 if(current!=NULL)
   Asview_set_links(current,prev,view,0);
 Asview_set_links(view,current,NULL,0);
 if(agent->views==NULL)
    agent->views= view;
 agent->view_counter++;
 return(1);
}


int Asagent_del_view(agent,view,flag)
struct AsagenT *agent;
struct AsvieW **view;
int flag;
{
 int ret;

 struct AsvieW *prev= NULL,*next= NULL;
 
 if(*view==NULL)
   return(0);
 prev= (*view)->prev;
 next= (*view)->next;
 Asview_destroy(view,0);
 if(prev==NULL)
   agent->views= next;
 agent->view_counter--;
 return(1);
}


int Asagent_find_view(agent,view,type,id,conn_name,fd,subscr,flag)
struct AsagenT *agent;
struct AsvieW **view;
char *type;     /* empty = any */
char *id;       /* empty = any */
char *conn_name;/* empty = any */
int fd;         /* <0    = any */
char *subscr;   /* empty = any */
int flag;
/*
 bit0= compare fd with input_fd rather than view output fd
 bit1= start search at *view->next rather than agent->views
*/
{
 int ret,input_fd,current_fd;
 struct AsvieW *current,*prev= NULL,*next= NULL;
 char *sconn_filename= NULL;

 if(flag&2) {
   if(*view==NULL)
     {ret= 0; goto ex;}
   current= (*view)->next;
 } else
   current=  agent->views;
 *view= NULL;

 while(current!=NULL) {
   Asview_get_fd(current,&input_fd,1);
   if(input_fd<0)
     Asview_get_fd(current,&input_fd,0);
   Asview_get_links(current,&prev,&next,0);
   if(type[0]==0 || strcmp(type,current->type)==0)
    if(id[0]==0 || strcmp(id,current->id)==0) {
     ret= Sconn_get_filename(current->sconn,&sconn_filename,1);
     if(ret<0)
       goto ex;
     if(ret==0)
       if(Sregex_string(&sconn_filename,"",0)<=0)
         {ret=  -1; goto ex;}
     if(conn_name[0]==0 || strcmp(conn_name,sconn_filename)==0) {
       current_fd= Sconn_get_fd(current->sconn,1);
       if(fd<0||(current_fd==fd&&!(flag&1))||
                (input_fd==fd&&(flag&1))) {
         if(subscr[0]==0 || Asview_is_subscribed(current,subscr,0)) {
           *view= current;
           ret= 1;
           goto ex;
         }
       }
     }
   }
   current= next;
 }
 ret= 0;
ex:;
 Sregex_string(&sconn_filename,NULL,0);
 return(ret);
}


int Asagent_view_is_enabled(agent,view,flag)
struct AsagenT *agent;
struct AsvieW *view;
int flag;
/*
 bit0= encapsulate
*/
{
 int ret,vfd,afd;

 if(!(agent->encapsulate_views||view->encapsulated||(flag&1)))
   return(1);
 Asview_get_fd(view,&vfd,1|2);
 if(agent->encapsulate_views||view->encapsulated)
   afd= agent->input_fd;
 else
   afd= Asagent_get_event_connection(agent,0);
 if(vfd>=0 && vfd!=afd)
   return(0);
 return(1);
}


int Asagent_notify_closedconn(agent,fd,flag)
struct AsagenT *agent;
int fd;
int flag;
/*
 bit0= preserve fd , do not set to -1
*/
{
 int vfd;
 struct AsvieW *current,*next;
 
 if(fd==-1)
   return(0);
 /* remove all views using that connection */
 current= agent->views;
 while(current!=NULL) {
   Asview_get_fd(current,&vfd,1|2);
   next= current->next;
   if(vfd==fd) {
     if(!(flag&1))
       Asview_set_fd(current,-1,0);
     Asagent_del_view(agent,&current,0);
   }
   current= next;
 }
 /* remove or mark all pending events originating from that connection */
 Asqueue_remove_fd_events(agent->queue,fd,agent->preserve_orphan_events);
 return(1);
}
 

int Asagent_notify_prompt(agent,flag)
struct AsagenT *agent;
int flag;
/*
 bit0= unprompt
 bit1= obtain idx, count from agent->viewmsg
*/
{
 int ret,idx,count,dummy;
 static char dummytext[2]= {"0"};
 char *idxtext,*counttext,*adrpt;
 struct AsvieW *view,*prev= NULL,*next= NULL;

 if(flag&2) {
   ret= Asviewmsg_fetch_field(agent->viewmsg,"idx",&idxtext,&dummy,0);
   if(ret<0)
     goto ex;
   if(ret==0)
     idxtext= dummytext;
   ret= Asviewmsg_fetch_field(agent->viewmsg,"count",&counttext,&dummy,0);
   if(ret<0)
     goto ex;
   if(ret==0)
     idxtext= dummytext;
   sscanf(idxtext,"%ld",&idx);
   idx--;
   sscanf(counttext,"%ld",&count);
 } else {
   ret= Asagent_determine_current(agent,&adrpt,&idx,&count,0);
   if(ret<=0)
     goto ex;
   idx++;                                /* external idx count begins with 1 */
 }
 view= agent->views;
 for(view= agent->views;view!=NULL;view= next) {
   Asview_get_links(view,&prev,&next,0);
   if(!Asagent_view_is_enabled(agent,view,0))
 continue;
   Asview_notify_prompt(view,idx,count,flag&1);
 }
 ret= 1;
ex:;
 return(ret);
}


int Asagent_notify_mark(agent,mark_id,mark_pt,flag)
struct AsagenT *agent;
char *mark_id;
struct LstrinG *mark_pt;
int flag;
/*
 bit0= mark end
 bit1= end complete agent->markstack
 bit2= with bit1 stop before deleting (struct LstrinG *) mark_pt
 bit8= reply rather than mark
*/
{
 int ret;

 struct AsvieW *view,*prev= NULL,*next= NULL;
 struct LstrinG *lstring,*stop_mark;

 if(flag&2)
   goto end_markstack;
 view= agent->views;
 for(view= agent->views;view!=NULL;view= next) {
   Asview_get_links(view,&prev,&next,0);
   if(!Asagent_view_is_enabled(agent,view,1))               /* encapsulated */
 continue;
   Asview_notify_mark(view,mark_id,flag&(1|256));
 }
 return(1);

end_markstack:;
 if(flag&4){
   stop_mark= mark_pt;
   for(lstring= agent->markstack->next; lstring!=NULL && lstring!=stop_mark;
       lstring= lstring->next);
   if(lstring!=stop_mark)
     return(2); /* stop_mark has vanished */
 }
 while(agent->markstack->next!=NULL){
   if(flag&4)
     if(stop_mark==agent->markstack->next)
 break;
   ret= Asagent_notify_mark(agent,agent->markstack->next->text,NULL,
                             1|(flag&256));
   if(ret<0)
     return(ret);
   Lstring_destroy(&(agent->markstack->next),1);
 }
 return(1);
}


int Asagent_notify_file(agent,type,filev,filec,index,flag)
struct AsagenT *agent;
char *type;
char **filev;
int filec;
int index;
int flag;
/*
 bit0= hide rather than show
 bit1= do not show 'child' type
 bit2= report files via ls -l
 bit3= show empty file lists too
 bit4= use current viewmsg of agent 
 bit5= do not show non 'child' views
*/
{
 struct AsvieW *view,*prev= NULL,*next= NULL;

 if(strcmp(type,"current_file")==0 && (agent->disable_internal&1))
   flag|= 2;
 if(strcmp(type,"double_files")==0 && (agent->disable_internal&2))
   flag|= 2;
 for(view= agent->views;view!=NULL;view= next) {
   Asview_get_links(view,&prev,&next,0);
   if(!Asagent_view_is_enabled(agent,view,0))
 continue;
   Asview_notify_file(view,type,filev,filec,index,flag&63);
 }
 return(1);
}


int Asagent_notify_ask(agent,id,type,text,constraint,flag)
struct AsagenT *agent;
char *id;
char *type;
char *text;
char *constraint;
int flag;
{
 struct AsvieW *current,*prev= NULL,*next= NULL;

 for(current= agent->views;current!=NULL;current= next) {
   Asview_get_links(current,&prev,&next,0);
   if(!Asagent_view_is_enabled(agent,current,0))
 continue;
   Asview_notify_ask(current,type,id,text,constraint,0);
 }
 return(1);
}
 

int Asagent_notify_list_change(agent,idx,action,item,flag)
struct AsagenT *agent;
int idx;
char *action;
char *item;
int flag;
{
 struct AsvieW *current,*prev= NULL,*next= NULL;

 for(current= agent->views;current!=NULL;current= next) {
   Asview_get_links(current,&prev,&next,0);
   if(!Asagent_view_is_enabled(agent,current,0))
 continue;
   Asview_notify_list_change(current,idx,action,item,0);
 }
 return(1);
}


int Asagent_stdout(agent,text,flag)
struct AsagenT *agent;
char *text;
int flag;
/*
 bit0= append \n
 bit1= notify only, do not Asinput_stdout()
 bit2= flush buffers after output
 bit3= Asinput_stdout() only, do not notify
*/
{
 int ret;
 struct AsvieW *current,*prev= NULL,*next= NULL;

 if(!((flag&2)||(agent->disable_internal&4)||agent->request_mode))
   Asinput_stdout(agent->queue->input,text,flag&5);
 if(flag&8)
   return(1);
 if(text[0]==0 && !(flag&1))
   return(1);
 for(current= agent->views;current!=NULL;current= next) {
   Asview_get_links(current,&prev,&next,0);
   if(!Asagent_view_is_enabled(agent,current,0))
 continue;
   Asview_notify_text(current,"stdout",text,(flag&1));
 }
 return(1);
}


int Asagent_stderr(agent,text,flag)
struct AsagenT *agent;
char *text;
int flag;
/*
 bit0= append \n
 bit1= notify only, do not Asinput_stderr()
 bit2= flush buffers after output
 bit3= Asinput_stderr() only, do not notify
*/
{
 int ret;
 struct AsvieW *current,*prev= NULL,*next= NULL;

 if(!((flag&2)||(agent->disable_internal&8)))
   Asinput_stderr(agent->queue->input,text,flag&5);
 if(flag&8)
   return(1);
 for(current= agent->views;current!=NULL;current= next) {
   Asview_get_links(current,&prev,&next,0);
   if(!Asagent_view_is_enabled(agent,current,0))
 continue;
   Asview_notify_text(current,"stderr",text,(flag&1));
 }
 return(1);
}


int Asagent_del_broken_views(agent,flag)
struct AsagenT *agent;
int flag;
{
 struct AsvieW *current,*prev= NULL,*next= NULL;
 int ret;

 current= agent->views;
 while(current!=NULL) {
   Asview_get_links(current,&prev,&next,0);
   if(current->broken)
     Asagent_del_view(agent,&current,0);
   current= next;
 }
 ret= Asrm_process_all(agent->deferred_rm_jobs,0);
 if(ret<0)
   return(ret);
 return(1);
}


int Asagent_count_services(agent,flag)
struct AsagenT *agent;
int flag;
/*
 bit0= count internal input as a service
*/
{
 int ret;

 ret= Asqueue_count_services(agent->queue,flag&1);
 return(ret);
}
 

int Asagent_default_kbd(agent,flag)
struct AsagenT *agent;
int flag;
{
 int ret;

 ret= Asqueue_default_kbd(agent->queue,flag);
 return(ret);
}


int Asagent_pipe_stdtxt(agent,flag)
struct AsagenT *agent;
int flag;
{
 close(fileno(stdout));
 dup(agent->stdout_pipe[1]);
 close(fileno(stderr));
 dup(agent->stderr_pipe[1]);

/*
 fprintf(stdout,"testing stdout\n");
 fprintf(stderr,"testing stderr\n");
*/

 return(1);
}


int Asagent_ask(agent,type,text,constraint,flag)
struct AsagenT *agent;
char *type;
char *text;
char *constraint;
int flag;
/*
 bit0= append \n
 bit1= do not increment ask_counter
*/
{
 int ret;
 char id[Asview_id_strL];

 if(!(flag&2))
   agent->ask_counter++;
 sprintf(id,"%ld",agent->ask_counter);
 if(text[0]!=0)
   Asagent_stderr(agent,text,flag&1);
 Asagent_notify_ask(agent,id,type,text,constraint,0);
 return(1);
}


int Asagent_fetch_token(agent,reply,flag)
struct AsagenT *agent;
char **reply;
int flag;
/*
 bit0= set blocking mode according to bit1 (halfdelay else, if possible)
 bit1= blocking, non blocking else
 bit2= do not convert reply character by prog
return:
 -1 = fatal error
  0 = no token read
  1 = token read
*/
{
 int ret;
 ret= Asqueue_fetch_token(agent->queue,reply,flag);
 return(ret);
}


int Asagent_fetch_line(agent,question,reply,flag)
struct AsagenT *agent;
char *question;
char **reply;
int flag;
/*
 bit0= do not print question
 bit1= do not ask at all
*/
{
 int ret;

 if(!(flag&2)){
   if((flag&1))
     Asagent_ask(agent,"line","","",1);
   else
     Asagent_ask(agent,"line",question,"",1);
 }
 ret= Asqueue_fetch_line(agent->queue,reply,0);
 if(!(flag&2))
   Asagent_ask(agent,"cancel","","",2);
 return(ret);
}


int Asagent_fetch_yesno(agent,question,yes,flag)
struct AsagenT *agent;
char *question;
int *yes;
int flag;
/*
 bit0= line input with Return key
*/
{
 int ret,c;
 char *reply= NULL;

 *yes= 0;
 Asagent_ask(agent,"char",question,"YyJjNn10",1);
 if(flag&1){
   ret= Asagent_fetch_line(agent,"",&reply,1|2);
 } else {
   ret= Asagent_fetch_token(agent,&reply,1|2|4);
 }
 if(ret<=0)
   goto ex;
 c= reply[0];
 if(c=='Y' || c=='y' || c=='J' || c=='j' || c=='1')
   *yes= 1;
 else
   *yes= 0;
 ret= 1;
ex:;
 Asagent_ask(agent,"cancel","","",2);
 Sregex_string(&reply,NULL,0);
 return(ret);
}


int Asagent_stdout_bar(agent,flag)
struct AsagenT *agent;
int flag;
/*
 bit0= simple bar without index numbers
*/
{
 char line[256],*adrpt;
 int ret,idx,count;

 if(flag&1)
   strcpy(line,"-------------------------------------------------------------------------------");
 else {
   ret= Asagent_determine_current(agent,&adrpt,&idx,&count,0);
   if(ret!=1) 
     idx= -1;
   sprintf(line,"-- %6ld : %-6ld %60.60s",idx+1,count,
           "------------------------------------------------------------",1);
 }
 Asagent_stdout(agent,line,1);
 return(1);
}


int Asagent_print_fileinfo(agent,adr,flag)
struct AsagenT *agent;
char *adr;
int flag;
{
 int ret,status;
 char line[SfileadrL],esc_file[SfileadrL],*fnpt;

 ret= Sfile_try_local_adr(adr,&fnpt,0);
 if(ret<0)
   return(ret);
 sprintf(line,"ls -l %s",Sfile_esc_shell(fnpt,esc_file,0));
 Asagent_shell(agent,line,&status,0);
 Asagent_stdout(agent,"",1);
 return(1);
}


int Asagent_show_current(agent,adr,index,flag)
struct AsagenT *agent;
char *adr;
int index;
int flag;
/*
 bit0= print file info
*/
{
 int ret,no_internal;
 struct AsvieW *current,*prev= NULL,*next= NULL;

 no_internal= (agent->disable_internal&1)<<1;
 for(current= agent->views;current!=NULL;current= next) {
   Asview_get_links(current,&prev,&next,0);
   if(!Asagent_view_is_enabled(agent,current,0))
 continue;
   Asview_notify_file(current,"current_file",&adr,1,index,
                       no_internal|(flag&1)<<2);
 }
 Asagent_stdout(agent,"",4);                    /* flush text output */
 return(1);
}


int Asagent_seems_known(agent,adr,filec,filev,flag)
struct AsagenT *agent;
char *adr;
int *filec;
char ***filev;
int flag;
/*
 bit0= use opened reg_adr
 bit1= search even if in guarded location
*/
{
 int ret;

 if(agent->App_seems_known == Asagent_seems_known)
   return(0);
 ret= agent->App_seems_known(agent->app,adr,filec,filev,flag);
 return(ret);
}


int Asagent_notify_doubles(agent,filev,filec,flag)
struct AsagenT *agent;
char **filev;
int filec;
int flag;
/*
 bit0= print file info
*/
{
 int ret,no_internal,i;
 struct AsvieW *current,*prev= NULL,*next= NULL;

 agent->doubles_shown= 0;
 Asagent_stdout(agent,"=?=?=?=?=?=?=?=?=?=?=?=?=?=?=?=",1);
 no_internal= (agent->disable_internal&2);
 if(flag&1)
   for(i=0;i<filec;i++)
     Asagent_print_fileinfo(agent,filev[i],0);
 for(current= agent->views;current!=NULL;current= next) {
   Asview_get_links(current,&prev,&next,0);
   if(!Asagent_view_is_enabled(agent,current,0))
 continue;
   Asview_notify_file(current,"double_files",filev,filec,i-1,no_internal);
 }
 if(filec>0)
   agent->doubles_shown= 1;
 ret= 1;
ex:;
 Asagent_stdout(agent,"",4);              /* flush text output */
 return(ret);
}


int Asagent_show_doubles(agent,adr,flag)
struct AsagenT *agent;
char *adr;
int flag;
/*
 bit0= print file info
 bit1= look for doubles if not totally disabled
*/
{
 int ret,filec= 0,always=0;
 char **filev= NULL;

 if(agent->doubles_shown)
   Asagent_hide(agent,2);
 if(agent->look_for_doubles<=0)
   {ret= 2; goto ex;}
 if(agent->look_for_doubles>=2 || flag&2)
   always= 2;
 ret= Asagent_seems_known(agent,adr,&filec,&filev,always);
 if(ret<0)
   goto ex;
 if(ret==0 || ret==2)
   { ret= 2; goto ex; }
 ret= Asagent_notify_doubles(agent,filev,filec,flag&1);
ex:;
 Sfile_destroy_argv(&filec,&filev,0);
 return(ret);
}


int Asagent_hide(agent,flag)
struct AsagenT *agent;
int flag;
/*
 bit0= hide current
 bit1= hide doubles
 bit2= only hide views of type "child"
*/
{
 int ret,no_internal;
 struct AsvieW *current,*prev= NULL,*next= NULL;

 for(current= agent->views; current!=NULL; current= next) {
   Asview_get_links(current,&prev,&next,0);
   if(!Asagent_view_is_enabled(agent,current,0))
 continue;
   if((flag&4)&&!strcmp(current->type,"child")==0)
 continue;
   if(flag&1) {
     no_internal= (agent->disable_internal&1)<<1;
     Asview_notify_file(current,"current_file",NULL,0,-1,1|no_internal);
   }
   if((flag&2)&&(agent->doubles_shown)) {
     no_internal= (agent->disable_internal&2);
     Asview_notify_file(current,"double_files",NULL,0,-1,1|no_internal);
   }
 }
 agent->doubles_shown= 0;
 return(1);
}



int Asagent_get_first_double(agent,adr,reply,flag)
struct AsagenT *agent;
char *adr;
char **reply;
int flag;
{
 int ret;
 char **filev= NULL;
 int filec= 0;

 /* >>> try to get the double list from double_viewer */;

 ret= Asagent_seems_known(agent,adr,&filec,&filev,2);
 if(ret<0)
   goto ex;
 if(ret>0 && filec>0){
   *reply= filev[0];
   filev[0]= NULL; /* to protect *reply from being destroyed */
   Sfile_destroy_argv(&filec,&filev,0);
 } else {
   Asagent_stderr(agent,"\n--- No duplicate files found\n\n",1);
   ret= 0;
   goto ex;
 }
 ret= 1;
ex:;
 return(ret);
}



int Asagent_check_icv(agent,flag)
struct AsagenT *agent;
int flag;
/*
 flag:
    bit0= repair regardless of agent->repair_icv_idx
 return:
  <=0 : error
    1 : nothing interesting happened
    2 : viewer died peacefully or by external reasons
    3 : viewer died with non zero exit value, file may have been altered
    4 : viewer died with non zero exit value, no action 
*/
{
 int ret,exitvalue,idx,count;
 char *adrpt;

 ret= Asview_has_died(agent->internal_current_view,&exitvalue,0);
 if(ret<0)
   return(ret);
 if(ret==0)
   return(1);
 if(ret>1 || exitvalue==0) {
   Asagent_stdout(agent,
                 "\n*** ouch: internal current viewer has been murdered.\n",1);
   Asview_hide(agent->internal_current_view,"",0);
   return(2);
 }
 if(!agent->repair_icv)
   return(4);
 ret= Asagent_determine_current(agent,&adrpt,&idx,&count,0);
 if(ret<=0)
   return(ret);
 if(agent->repair_icv_idx==idx && !(flag&1)) 
   return(4);
 ret= Asqueue_synthetic(agent->queue,"-jpgb",-1,"/",1|4);
 if(ret<=0)
   return(ret);
 agent->repair_icv_idx= idx;
 return(4);
}
 

int Asagent_eval(agent,in_text,result_pt,flag)
struct AsagenT *agent;
char *in_text;
char **result_pt;
int flag;
{
 int ret;

 if(agent->App_eval == Asagent_eval) {
   /* just a dummy, for the real thing use  Asagent_attach_app() */
   if(Sregex_string(result_pt,in_text,0)<=0)
     return(-1);
   return(1);
 }
 ret= agent->App_eval(agent->app,in_text,result_pt,flag);
 return(ret);
}


int Asagent_check_pipes(agent,flag)
struct AsagenT *agent;
int flag;
/*
 bit0= set blocking mode according to bit1 (halfdelay else, if possible)
 bit1= blocking, non blocking else
*/
{
 int ret;
 char *dummy= NULL;

 ret= Asqueue_fetch_token(agent->queue,&dummy,16|(flag&3));
 return(ret);
}


int Asagent_shell(agent,cmd,status,flag)
struct AsagenT *agent;
char *cmd;
int *status;
int flag;
{
 extern char **environ;

 int ret;
 pid_t child_pid;
 char *argv[4];

 child_pid= fork();
 if(child_pid==-1) 
   return(-1);
 if(child_pid==0) {
   /* this is the child */

   /* never call Asagent_stdXXX() after this */
   Asagent_pipe_stdtxt(agent,0);
   argv[0]= "sh";
   argv[1] = "-c";
   argv[2] = cmd;
   argv[3] = NULL;
   execve("/bin/sh", argv, environ);
   fprintf(stderr,"--- execution of shell command failed:\n");
   fprintf(stderr,"    %s\n",cmd);
   exit(127);
 }

 /* this is the original process waiting for child to exit */
 do {
   /* try to read and print the reply */;
   Asagent_check_pipes(agent,0);
   ret= waitpid(child_pid,status,WNOHANG);
   if(ret==-1) {
     if(errno!=EINTR)
       return(0);
   } else if(ret==0) {
 continue;
   } else {
     Asagent_check_pipes(agent,1);
     return(1);
   }
 } while(1);
 ret= 1;
ex:
 return(ret);
}
   

int Asagent_send_cmd(agent,cmd,flag)
struct AsagenT *agent;
char *cmd;
int flag;
/*
 bit0= do not prepend -mark
*/
{
 int ret,fd;
 char *msg= NULL;
 struct AsvieW *view;
 struct SconN *sconn;

 if(agent==NULL)
   return(0);
 sconn= agent->client_sconn;
 if(sconn==NULL)
   return(0);
 if(flag&1)
   goto send_msg;
 /* prepend -mark: */
 fd= Asagent_get_event_connection(agent,0);
 if(fd<0) {

   /* >>> what about internal input ? */
   /* (for orphan events this is ok) */
   ret= 0;

 } else {
   ret= Asagent_find_view(agent,&view,"","","",fd,"",1);
   if(ret<0)
     goto ex;
 }
 if(ret>0) {
   if(Sregex_string(&msg,"-mark:",0)<=0)
     {ret= -1; goto ex;}
   if(Sregex_string(&msg,view->id,1)<=0)
     {ret= -1; goto ex;}
   if(Sregex_string(&msg,":",1)<=0)
     {ret= -1; goto ex;}
 }
send_msg:;
 if(Sregex_string(&msg,cmd,1)<=0)
   {ret= -1; goto ex;}
 if(Sregex_string(&msg,"\n",1)<=0)
   {ret= -1; goto ex;}
 ret= Sconn_write(sconn,msg,strlen(msg),0);
 if(ret<=0)
   {ret= 0; goto ex;}
 ret= 1;
ex:;
 Sregex_string(&msg,NULL,0);
 return(ret);
}


int Asagent_notification(agent,flag)
struct AsagenT *agent;
int flag;
/*
 return:
  <=0 : error
    1 : all went ok
    3 : abort client mode
    4 : end program
*/
{
 int ret,hflag,dummy,hide,filec= 0,copy_filec= 0,no_payload= 0,fd,l,mark_end;
 int notified_mark_end,request_mode,index= 0,idx;
 char *type,*text,*id,*constraint,*state,**filev= NULL,**copy_filev=NULL,*cpt;
 char *idx_text,*action,*item;
 char viewid[Asview_id_strL];
 struct AsviewmsG *msg;
 struct AsvieW *view;

 msg= agent->viewmsg;
 if(msg==NULL)
   return(0);
 if(agent->notified_mark_id!=NULL) 
   Asagent_set_event_connection(agent,agent->notified_mark_fd,0);
 request_mode= agent->request_mode;
 if(agent->notified_reply_id!=NULL) 
   agent->request_mode= 1;
 type= msg->type;
 if(strcmp(type,"init")==0) {
   /* >>> obtain and store remote view id */;
 } else if(strcmp(type,"end")==0) {
   ret= 3; /* abort client mode */
   goto ex;
 } else if(strcmp(type,"prompt")==0) {
   if(msg->fieldcount==0) 
     hflag= 1|2;
   else {
     hflag= 2;
     ret= Asviewmsg_fetch_field(agent->viewmsg,"idx",&text,&dummy,0);
     if(ret<0)
       goto ex;
     if(ret>0){
       sscanf(text,"%ld",&dummy);
       agent->remote_idx= dummy-1;
     }
     ret= Asviewmsg_fetch_field(agent->viewmsg,"count",&text,&dummy,0);
     if(ret<0)
       goto ex;
     if(ret>0){
       sscanf(text,"%ld",&dummy);
       agent->remote_count= dummy-1;
     }
   }
   Asagent_notify_prompt(agent,hflag);
   if((agent->end_on_flag&2)&&(msg->fieldcount>0)) {
     ret= 4;
     goto ex;
   }
 } else if(strcmp(type,"stdout")==0) {
   ret= Asviewmsg_fetch_field(agent->viewmsg,"text",&text,&dummy,0);
   if(ret<0)
     goto ex;
   Asagent_stdout(agent,text,4);
 } else if(strcmp(type,"stderr")==0) {
   ret= Asviewmsg_fetch_field(agent->viewmsg,"text",&text,&dummy,0);
   if(ret<0)
     goto ex;
   Asagent_stderr(agent,text,4); 
 } else if(strcmp(type,"current_file")==0 || strcmp(type,"double_files")==0 ||
           strcmp(type,"current_file_copy")==0 ||
           strcmp(type,"double_files_copy")==0) {
   hide= 0;
   if(msg->fieldcount<=0)
     hide= 1;
   ret= Asviewmsg_get_filev(msg,&filev,&filec,0);
   if(ret<=0)
     goto ex;
   ret= Asviewmsg_fetch_field(agent->viewmsg,"idx",&text,&dummy,0);
   if(ret<0)
     goto ex;
   if(ret==1)
     sscanf(text,"%ld",&index);
   else
     index= 0;
   index--;
   if(strcmp(type,"current_file")==0) {
     if(filec>0 && !hide)
       text= filev[0];
     else
       text= "";
     if(Sregex_string(&(agent->remote_adr),text,0)<=0)
       {ret= -1; goto ex;}
   }
   if(filec>0 || hide) {
     if(filec<msg->fieldcount && !hide) {
                                 /* file names and contents were transmitted */
       /* notify all non "child" views, using agent->viewmsg as data source */
       ret= Asagent_notify_file(agent,type,filev,filec,index,2|16);
       if(ret>0) {
         ret= Asview_obtain_copyfiles(agent->views,type,
                                       &copy_filev,&copy_filec,0);
         if(ret>0 && copy_filec>0) {
           /*  notify "child" view about copy names */;
           ret= Asagent_notify_file(agent,type,copy_filev,copy_filec,index,32);
         }
       }
     } else {
       ret= Asagent_notify_file(agent,type,filev,filec,index,hide);
     }
     if(ret<0)
       goto ex;
   }
 } else if(strcmp(type,"ask")==0) {
   ret= Asviewmsg_fetch_field(agent->viewmsg,"id",&id,&dummy,0);
   if(ret<0)
     goto ex;
   ret= Asviewmsg_fetch_field(agent->viewmsg,"type",&type,&dummy,0);
   if(ret<0)
     goto ex;
   ret= Asviewmsg_fetch_field(agent->viewmsg,"text",&text,&dummy,0);
   if(ret<0)
     goto ex;
   ret= Asviewmsg_fetch_field(agent->viewmsg,"constraint",&constraint,
                               &dummy,0);
   if(ret<0)
     goto ex;
   /* ??? do also ask internal */;
   Asagent_notify_ask(agent,id,type,text,constraint,0);
 } else if(strcmp(type,"mark")==0) {
   ret= Asviewmsg_fetch_field(agent->viewmsg,"state",&state,&dummy,0);
   if(ret<0)
     goto ex;
   ret= Asviewmsg_fetch_field(agent->viewmsg,"id",&id,&dummy,0);
   if(ret<0)
     goto ex;
   mark_end= 0;
   notified_mark_end= 0;
   if(strcmp(state,"end")==0) {
     mark_end= 1;
     if(agent->notified_mark_id!=NULL) 
       if(strcmp(agent->notified_mark_id,id)==0) 
         notified_mark_end= 1;
   }
   no_payload= 0;
   cpt= id;
   if(agent->notified_mark_id==NULL || notified_mark_end) {
     cpt= strchr(id,'/');
     if(cpt==NULL) {
       cpt= id+strlen(id);
       no_payload= 1;
     }
     l= cpt-id;
     if(l>=Asview_id_strL) 
       l= Asview_id_strL-1;
     strncpy(viewid,id,l);
     viewid[l]= 0;
     if(!no_payload)
       cpt++;
     /* determine input_fd from view-id */
     ret= Asagent_find_view(agent,&view,"",viewid,"",-1,"",0);
     if(ret<0)
       goto ex;
     if(ret>0)
       Asview_get_fd(view,&fd,1);
     else
       fd= -1;
   } 
   if(!mark_end) {
     if(agent->notified_mark_id==NULL) {
       /* start notification fd override */
       if(Sregex_string(&(agent->notified_mark_id),id,0)<=0)
         {ret= -1; goto ex;}
       agent->notified_mark_fd= fd;
       Asagent_set_event_connection(agent,fd,0);
     }
   }
   if(!no_payload)
     Asagent_notify_mark(agent,cpt,NULL,mark_end);
   if(notified_mark_end) {
     /* end notification fd override mode */;
     Sregex_string(&(agent->notified_mark_id),NULL,0);
     agent->notified_mark_fd= -1;
     Asagent_set_event_connection(agent,-1,1);
   }
   if(mark_end) 
     if(Asagent_check_end_on(agent,"mark",id,0)>0) {
       ret= 4;
       goto ex;
     }    
 } else if(strcmp(type,"reply")==0) {
   ret= Asviewmsg_fetch_field(agent->viewmsg,"state",&state,&dummy,0);
   if(ret<0)
     goto ex;
   ret= Asviewmsg_fetch_field(agent->viewmsg,"id",&id,&dummy,0);
   if(ret<0)
     goto ex;
   mark_end= 0;
   notified_mark_end= 0;
   if(strcmp(state,"end")==0) {
     mark_end= 1;
     if(agent->notified_reply_id!=NULL) 
       if(strcmp(agent->notified_reply_id,id)==0) 
         notified_mark_end= 1;
   }
   if(!mark_end) {
     if(agent->notified_reply_id==NULL) {
       /* start notification fd override */
       if(Sregex_string(&(agent->notified_reply_id),id,0)<=0)
         {ret= -1; goto ex;}
     }
   }
   Asagent_notify_mark(agent,id,NULL,mark_end|256);
   if(notified_mark_end)
     Sregex_string(&(agent->notified_reply_id),NULL,0);
 } else if(strcmp(type,"list_change")==0) {
   ret= Asviewmsg_fetch_field(agent->viewmsg,"idx",&idx_text,&dummy,0);
   if(ret<0)
     goto ex;
   sscanf(idx_text,"%ld",&idx);
   idx--;
   ret= Asviewmsg_fetch_field(agent->viewmsg,"action",&action,&dummy,0);
   if(ret<0)
     goto ex;
   ret= Asviewmsg_fetch_field(agent->viewmsg,"item",&item,&dummy,0);
   if(ret<0)
     goto ex;
   Asagent_notify_list_change(agent,idx,action,item,0);
 } else {
   Asagent_stderr(agent,"received unknown view message type : ",0);
   Asagent_stderr(agent,type,1);
   ret= 0;
   goto ex;
 }
 ret= 1;
ex:;
 agent->request_mode= request_mode;
 if(agent->notified_mark_id!=NULL) 
   Asagent_set_event_connection(agent,agent->notified_mark_fd,1);
 if(filev!=NULL)
   Smem_freE((char *) filev);
 if(copy_filev!=NULL)
   Smem_freE((char *) copy_filev);
 return(ret);
}


int Asagent_dispatch_msg(agent,text,textcount,rptpt,flag)
struct AsagenT *agent;
char *text;    /* text[textcount] must be 0, even if text already contains 0 */
int textcount;
char **rptpt;
int flag;
/*
 bit0= only process the first completed message

return:
 <=0 : error
   1 : all went normal
   2 : message still incomplete
   3 : end being client
   4 : end program
*/
{
 char *rpt;
 int ret;

 rpt= text;
 while(rpt-text<textcount) {
   ret= Asviewmsg_parse_head(&(agent->viewmsg),rpt,textcount-(rpt-text),
                              &rpt,0);
   if(ret!=1)
     goto ex;
   ret= Asviewmsg_parse_fields(agent->viewmsg,rpt,textcount-(rpt-text),
                                &rpt,0);
   if(ret==3)
     ret= 2;
   if(ret!=1)
     goto ex;
   ret= Asagent_notification(agent,0);
   Asviewmsg_destroy(&(agent->viewmsg),0);
   if(ret<=0)
     goto ex;
   if(ret==3 || ret==4)
     goto ex;
   if(flag&1)
 break;
 }

 ret= 1;
ex:;
 *rptpt= rpt;
 return(ret);
}


int Asagent_poll(agent,flag)
struct AsagenT *agent;
int flag;
/*
 bit0= permission to place -end at start of queue if ret==4
 bit1= start in data mode 
return:
 <=0 : error
   1 : all went normal
   3 : end being client
   4 : end program
*/
{
 int ret,count;
 char buf[SfileadrL+1],*rpt;

 /* asynchronous communication with child processes */
 if((flag&2) || !agent->data_mode) {
   Asview_try_outbuffers(agent->views,0);
   Asagent_consume_messages(agent,0);
   ret= Asagent_check_icv(agent,0);
   if(ret<0)
     goto ex;
 }

 /* notifications */
 if(agent->service_mode!=1 || agent->client_sconn==NULL)
   {ret= 1; goto ex;}
 while(1) {
   ret= Sconn_read(agent->client_sconn,buf,sizeof(buf)-1,&count,0);
   if(ret<=0)
     {ret= 0; goto ex;}
   if(ret==1) {
     if(count>=0) 
       buf[count]= 0; 
     ret= Asagent_dispatch_msg(agent,buf,count,&rpt,0);
     if(ret==4) {
       if((flag&1)) {
         ret= Asqueue_synthetic(agent->queue,"-end",-1,"/",1|4);
         if(ret>0)
           ret= 3;
       }
       goto ex;
     }
   } else {
     agent->data_mode= 0;
 break;
   }
 }

 ret= 1;
ex:;
 return(ret);
}


int Asagent_app_interpreter(agent,flag)
struct AsagenT *agent;
int flag;
{
 int ret;

 if(agent->App_interpreter==Asagent_interpreter)
   ret= Asagent_interpreter(agent,flag);
 else
   ret= agent->App_interpreter(agent->app,flag);
 return(ret);
}


int Asagent_client_interpreter(agent,flag)
struct AsagenT *agent;
int flag;
/*
 return values:
  <=0 = error
  1 = all went normal
  3 = end client service
*/
{
 int ret,count,service_mode_copy,fd,no_prepend= 0,i;
 char *cmd= NULL,*msg= NULL,buf[SfileadrL+1],*rpt,*username= NULL;
 struct SconN *sconn;
 struct AsvieW *view;
 static int bad_flooder= 0;

 agent->input_fd= Asagent_get_event_connection(agent,0);
 sconn= agent->client_sconn;
 ret= Asevent_get_cmd(agent->event,&cmd,0);
 if(ret<=0)
   goto ex;
 if(strncmp(cmd,"--imvagent",10)==0) {
   /* remove own module prefix if there */
   for(i=10;cmd[i]!=0;i++)
     cmd[i-10]= cmd[i];
   cmd[i]= 0;
 }

 if(cmd[0]==0||cmd[0]=='#'||cmd[0]=='!') {
   ;
 } else if(strncmp(cmd,"-add_view",9)==0 && cmd[9]!=0) {
   ret= Asagent_cmd_add_view(agent,cmd+10,0);
   if(ret>0)
     ret= 1;
   goto ex;
 } else if(strncmp(cmd,"-bundle",7)==0 && cmd[7]!=0) {
   no_prepend= 1;
 } else if(strcmp(cmd,"-end")==0) {
   ret= Asagent_get_permission(agent,"end","end",0);
   if(ret<=0)
     goto ex;
   ret= Asagent_get_current_user(agent,&username,0);
   if(ret<=0)
     goto ex;
   ret= Asqueue_synthetic(agent->queue,cmd,
                           Asagent_get_event_connection(agent,0),
                           username,1|4);
   if(ret>0)
     ret= 3;
   goto ex;
 } else if(strcmp(cmd,"-end_client")==0) {
   ret= Asagent_get_permission(agent,"end","end_client",0);
   if(ret>0)
     ret= 3;
   goto ex;
 } else if(strcmp(cmd,"-end_server")==0) {
   ret= Asagent_get_permission(agent,"end","end_server",0);
   if(ret<=0)
     goto ex;
   ret= Asagent_send_cmd(agent,"-end",1);
   if(ret>0)
     ret= 3;
   goto ex;
 } else if(strncmp(cmd,"-input_ready_fd",15)==0 && cmd[15]!=0) {
   agent->data_mode= 1;

   /* >>> determine role of reported file descriptor */
     /* >>> client_sconn , (nntpconn) */

   ret= Sconn_read(sconn,buf,sizeof(buf)-1,&count,0);
   if(ret<=0) {
     Asqueue_destroy_inconn(agent->queue,Sconn_get_fd(sconn,0),0);
     Asagent_stderr(agent,"+++ reply message connection from server broken",1);
     if(agent->server_crucial)
       ret= -1;
     goto ex;
   }
   if(ret==1) {
     if(count>=0) 
       buf[count]= 0; 
     ret= Asagent_dispatch_msg(agent,buf,count,&rpt,0);
     if(ret==4) {
       ret= Asqueue_synthetic(agent->queue,"-end",-1,"/",1|4);
       if(ret>0)
         ret= 3;
     } else if(ret==2)
       ret= 1;
     goto ex;
   } else
     {ret= 1; goto ex;}
 } else if(strncmp(cmd,"-internal",9)==0 && cmd[9]!=0) {
   ret= Asagent_cmd_internal(agent,cmd+10,0);
   if(ret>0)
     ret= 1;
   goto ex;
 } else if(strncmp(cmd,"-local_cmd",10)==0 && cmd[10]!=0) {
   ret= Asagent_get_permission(agent,"peer","local_cmd",0);
   if(ret<=0)
     goto ex;
   ret= Asagent_execute_subcmd(agent,cmd+11,(flag&2)|8);
   goto ex;
 } else if(strncmp(cmd,"-mark",5)==0 && cmd[5]!=0) {
   ret= Asagent_cmd_mark(agent,cmd+6,flag&2);
   if(ret!=2)
     goto ex;
 } else if(strcmp(cmd,"-queue_canceled")==0) {
   ret= Asagent_get_permission(agent,"cancel","queue_canceled",0);
   if(ret<=0)
     goto ex;
   /* send cancel command to server */
   cmd[0]= 27;
   cmd[1]= 0;
 } else if(strncmp(cmd,"-request",8)==0 && cmd[8]!=0) {
   ret= Asagent_cmd_mark(agent,cmd+9,(flag&2)|256);
   if(ret!=2)
     goto ex;
 } else if(strncmp(cmd,"-show_copy",10)==0 && cmd[10]!=0) {
   ret= Asagent_cmd_show_copy(agent,cmd+11,0);
   if(ret>0)
     ret= 1;
   goto ex;
 } else if(strncmp(cmd,"-tcp_service",12)==0 && cmd[12]!=0) {
   ret= Asagent_cmd_tcp_service(agent,cmd+13,0);
   if(ret>0)
     ret= 1;
   goto ex;
 } else if(strncmp(cmd,"-user",5)==0 && cmd[5]!=0) {
   ret= Asagent_cmd_user(agent,cmd+6,0);
   if(ret!=2)
     goto ex;
 }
 /* get original command again */
 ret= Asevent_get_cmd(agent->event,&cmd,0);
 if(ret<=0)
   goto ex;

 ret= Asagent_send_cmd(agent,cmd,no_prepend);
 if(ret<=0)
   goto ex;

 if(strcmp(cmd,"-end\n")==0 || strcmp(cmd,"-end")==0)
   ret= 3;
 else
   ret= 1;
 if(bad_flooder && ret==3)
   ret= 1;

ex:;
 Sregex_string(&msg,NULL,0);
 Sregex_string(&cmd,NULL,0);
 Sregex_string(&username,NULL,0);
 return(ret);
}


int Asagent_clientloop(agent,flag)
struct AsagenT *agent;
int flag;
/*
 bit0= reset file item index
 bit1= quiet
 bit15= return on idle
*/
/*
 return:
 <=0 : error
 1   : ok
 3   : end agent service
*/
{
 int ret,count,service_mode_copy,apcmem;
 char buf[SfileadrL+1],*rpt;
 struct SconN *sconn;

 if(agent==NULL)
   return(0);

 apcmem= agent->permission_check;
 agent->permission_check= 1;      /* just in case we got here during startup */
 sconn= agent->client_sconn;
 service_mode_copy= agent->service_mode;
 if(!(flag&2))
   Asagent_stdout(agent,"entering client loop",1);
 agent->service_mode= 1;

 while(1) {
   Asagent_establish_alarm(agent,0);                /* enable idle alarm */
   while(1) {
     if(!agent->data_mode) {
       Asview_try_outbuffers(agent->views,0);
       Asagent_consume_messages(agent,0);
       ret= Asagent_check_icv(agent,0);
       if(ret<0)
         goto ex;
     }
     Asevent_destroy(&(agent->event),0);
     Asagent_reset_input_source(agent,0);
     ret= Asqueue_advance(agent->queue,&(agent->event),agent->data_mode<<1);
     if(ret<0)
       goto ex;
     if(ret>0)
   break;
     agent->data_mode= 0;
     if((flag&(1<<15))||agent->loop_return_on_idle)
       {ret= 2; goto ex;}
   }
   Asagent_establish_alarm(agent,8);                /* disable idle alarm */
   ret= Asagent_app_interpreter(agent,4);
   if(ret<=0)
     goto ex;
   if(ret==3)
 break;
 }
 ret= 1;
ex:;
 Asview_try_outbuffers(agent->views,0);
 Asagent_consume_messages(agent,0);
 if(!(flag&2))
   Asagent_stdout(agent,"leaving client loop",1);
 if(ret==2)
   ret= 1;
 else
   agent->service_mode= service_mode_copy;
 agent->permission_check= apcmem;
 return(ret);
}


int Asagent_consume_messages(agent,flag)
struct AsagenT *agent;
int flag;
{
 int ret,fd;
 char *message= NULL,*origin= NULL;

 if(agent->access==NULL)
   return(0);
 do {
   ret= Saccess_consume_last(agent->access,"message","stdout","any",
                             &origin,&message,0);
   if(ret<0)
     goto ex;
   if(ret==0)
 break;
   if(Sregex_string_to_int(origin,&fd,0)<=0)
     fd= -1;
   Asagent_set_event_connection(agent,fd,0);
   Asagent_stdout(agent,message,1);
   Asagent_set_event_connection(agent,fd,1);
 } while(1);
 do {
   ret= Saccess_consume_last(agent->access,"message","stderr","any",
                             &origin,&message,0);
   if(ret<0)
     goto ex;
   if(ret==0)
 break;
   if(Sregex_string_to_int(origin,&fd,0)<=0)
     fd= -1;
   Asagent_set_event_connection(agent,fd,0);
   Asagent_stderr(agent,message,1|8);
   Asagent_set_event_connection(agent,fd,1);
 } while(1);
 ret= 1;
ex:;
 Sregex_string(&message,NULL,0);
 Sregex_string(&origin,NULL,0);
 return(ret);
}


int Asagent_open_outfile(agent,adr,purpose,flag)
struct AsagenT *agent;
char *adr;
char *purpose;
int flag;
{
 int fd;

 fd= open(adr,O_WRONLY|O_NONBLOCK);
 if(fd==-1){
   Asagent_stderr(agent,"--- cannot open file for ",0);
   Asagent_stderr(agent,purpose,0);
   Asagent_stderr(agent," :",1);
   Asagent_stderr(agent,adr,1);
   Asagent_stderr(agent,strerror(errno),1);
 }
 return(fd);
}


int Asagent_make_view(agent,view,viewtype,filetype,filename,fd,flag)
struct AsagenT *agent;
struct AsvieW **view;
char *viewtype;
int filetype;
char *filename;
int fd;
int flag;
/*
 bit0= do not attach sconn
*/
{
 int ret,sconn_fd,efd;
 char id[81];
 struct SconN *sconn= NULL;

 if(fd<0 && !(flag&1))
   {ret= 0; goto ex;}
 agent->view_counter++;
 sprintf(id,"%ld",agent->view_counter);
 ret= Asview_new(view,agent,id,viewtype,NULL,0,0);
 if(ret<=0)
   goto ex;
 if(flag&1)
   goto add_to_agent;

 /* find event originator among input connections */
 efd= Asagent_get_event_connection(agent,0);
 if(efd>=0) {
   ret= Asqueue_find_sconn(agent->queue,&sconn,NULL,efd,0);
 } else if(efd==-1) {
   ret= Asqueue_find_sconn(agent->queue,&sconn,NULL,fileno(stdout),0);
 } else {
   ret= 0;
   goto ex;
 }
 if(ret<0)
   goto ex;
 if(ret>0) {
   sconn_fd= Sconn_get_fd(sconn,1);
   if(sconn_fd<0) {
     /* if output channel (still) invalid : occupy by  fd  */
     ret= Sconn_attach_fd(sconn,filetype,filename,fd,1);
     if(ret<=0)
       goto ex;
   } else if(sconn_fd!=fd) {
     /* if it is already occupied by another fd, a new SconN is needed */
     sconn= NULL;
   }
 }
 ret= Asview_attach_sconn(*view,sconn,filetype,filename,fd,0);
 if(ret<=0)
   goto ex;

add_to_agent:;
 ret= Asagent_add_view(agent,*view,0);
 if(ret<=0)
   goto ex;

 ret= 1;
ex:;
 return(ret);
}


int Asagent_obtain_fd_type(agent,connection,fd,filetype,flag)
struct AsagenT *agent;
char *connection;
int *fd;
int *filetype;
int flag;
{
 int ret,efd;
 struct SconN *sconn= NULL;

 *fd= -1;
 *filetype= -1;
 if(strcmp(connection,"-")==0) {
   efd= Asagent_get_event_connection(agent,0);
   if(efd>=0) {
     ret= Asqueue_find_sconn(agent->queue,&sconn,NULL,efd,0);
     if(ret<0)
       goto ex;
   } else if(efd==-1) {
     *fd= fileno(stdout);
     *filetype= 5;                                      /* marks borrowed fd */
   } else { 
     ret= 0; goto ex;                                        /* orphan event */
   }
 } else {
   ret= Asqueue_find_sconn(agent->queue,&sconn,connection,-1,1|2);
   if(ret<0)
     goto ex;
 }
 if(sconn!=NULL) {
   *fd= Sconn_get_fd(sconn,1|4);    /* possibly get two-way capable input fd */
   *filetype= Sconn_get_filetype(sconn,1|4);
 }
 /* finally if everything failed, try to open as existing file */
 if(*fd<0) {
   if(strcmp(connection,"-")==0)
     {ret= 0; goto ex;}
   *fd= Asagent_open_outfile(agent,connection,"-show_copy",0);
   if(*fd==-1)
     { ret= 0; goto ex; }
   *filetype= 0;
 }
 ret= 1;
ex:
 return(ret);
}


int Asagent_get_current_user(agent,username,flag)
struct AsagenT *agent;
char **username;
int flag;
/*
flag:
 bit0= get authentication user (ignore agent->current_users)

return:
 <=0 = error
   1 = user according to authentication
   2 = user according to transmitted user name
*/
{
 int ret;
 struct SconN *sconn= NULL;

 if(agent->current_users!=NULL)
   if(agent->current_users->next!=NULL && !(flag&1)) {
     if(Sregex_string(username,agent->current_users->next->text,0)<=0)
       {ret= -1; goto ex;}
     ret= 2; goto ex;
   }

 ret= Asagent_get_event_connection(agent,0);
 if(ret==-1) {
   if(Sregex_string(username,"internal_owner",0)<=0)
     {ret= -1; goto ex;}
 } else if(ret==-2) {
   if(Sregex_string(username,"external_anonymous",0)<=0)
     {ret= -1; goto ex;}
 } else {
   if(agent->override_event_fd) {

     /* >>> determine user of the view addressed by the override */

     ret= Sregex_string(username,"internal_view_reply",0);
   } else {
     ret= Asevent_get_username(agent->event,username,0);
   }
   if(ret<=0)
     goto ex;
 }
 ret= 1;
ex:;
 return(ret);
}


int Asagent_get_user_perm(agent,username,class,action,flag)
struct AsagenT *agent;
char *username;
char *class;
char *action;
int flag;
/*
 bit0= questionable user (introduced by another one)
 bit2= for Saccess_find_value() : directory+filestart comparison
*/
{
 int ret,class_age,action_age,questionable_user=0,type,illegal_link=0;
 char *classaction= NULL,*class_value= NULL,*action_value= NULL;
 char *auth_username= NULL,value[80];

 if(!agent->permission_check)
   return(2);
 value[0]= 0;
 value[sizeof(value)-1]= 0;
 if(flag&1)
   questionable_user= 1;

 ret= Saccess_find_value(agent->access,"permission",username,class,
                         &class_value,flag&4);
 if(ret<0)
   goto ex;
 class_age= ret;
 if(Sregex_string(&classaction,class,0)<=0)
   {ret= -1; goto ex;}
 if(Sregex_string(&classaction,"-",1)<=0)
   {ret= -1; goto ex;}
 if(Sregex_string(&classaction,action,1)<=0)
   {ret= -1; goto ex;}
 ret= Saccess_find_value(agent->access,"permission",username,classaction,
                         &action_value,flag&4);
 if(ret<0)
   goto ex;
 action_age= ret;
 if(action_age>0 && (class_age==0 || class_age>action_age)) {
   strncpy(value,action_value,sizeof(value)-1);
   if(flag&4) {
     type= Sfile_type(action,2);
     if(type==3 || type==5) {
       if(strcmp(value,"permit")==0 || strcmp(value,"allow")==0 || value[0]==0)
         illegal_link= 1;
       strcpy(value,"deny");
     }
   }
 } else if(class_age>0) 
   strncpy(value,class_value,sizeof(value)-1);
 if(strcmp(value,"permit")==0 || strcmp(value,"allow")==0 || value[0]==0)
   ret= 1;
 else
   ret= 0;
ex:;
 if(ret==0) {
   Asagent_stderr(agent,"Permission denied for user '",0);
   Asagent_stderr(agent,username,0);
   if(questionable_user) {
     Asagent_stderr(agent,"' introduced by user '",0);
     Asagent_get_current_user(agent,&auth_username,1);
     Asagent_stderr(agent,auth_username,0);
   }
   Asagent_stderr(agent,"'\nto perform in class '",0);
   Asagent_stderr(agent,class,0);
   Asagent_stderr(agent,"' :\n  ",0);
   Asagent_stderr(agent,action,1);
   if(illegal_link)
     Asagent_stderr(agent,"(symbolic link or multiple hardlink detected)",1);
   agent->keep_views= 1;
 }
 Sregex_string(&classaction,NULL,0);
 Sregex_string(&auth_username,NULL,0);
 return(ret);
}


int Asagent_get_permission(agent,class,action,flag)
struct AsagenT *agent;
char *class;
char *action;
int flag;
/*
 bit0= check with authenticated user only
 bit1= permit everything to authenticated user "/"
 bit2= for Asagent_get_user_perm() : directory+filestart comparison
*/
{
 int ret,class_age,action_age,questionable_user=0;
 char *username= NULL;
 struct LstrinG *lstring= NULL;

 if(!agent->permission_check)
   return(2);
 if(flag&2) {
   ret= Asagent_get_current_user(agent,&username,1);
   if(ret<=0)
     goto ex;
   if(strcmp(username,"/")==0)
     {ret= 2; goto ex;}
 }
 for(lstring= agent->current_users->next;lstring!=NULL;lstring= lstring->next){
   if(Sregex_string(&username,lstring->text,0)<=0)
     {ret= -1; goto ex;};
   ret= Asagent_get_user_perm(agent,username,class,action,1|(flag&4));
   if(ret<=0)
     goto ex;
 }
 ret= Asagent_get_current_user(agent,&username,1);
 if(ret<=0)
   goto ex;
 ret= Asagent_get_user_perm(agent,username,class,action,flag&4);
 if(ret<=0)
   goto ex;
 ret= 1;
ex:;
 Sregex_string(&username,NULL,0);
 return(ret);
}


int Asagent_end_on_mask(agent,cmd,chip,prefix,flag)
struct AsagenT *agent;
char *cmd;
int *chip;
int *prefix;
int flag;
{
 int ret;

 if(strncmp(cmd,"list_end",8)==0){
   *chip= 1;
   *prefix= 8;
 } else if(strncmp(cmd,"prompt",6)==0){
   *chip= 2;
   *prefix= 6;
 } else if(strncmp(cmd,"timeout",7)==0){
   *chip= 4;
   *prefix= 7;
 } else if(strncmp(cmd,"idle",4)==0){
   *chip= 8;
   *prefix= 4;
 } else if(strncmp(cmd,"mark",4)==0){
   *chip= 16;
   *prefix= 4;
 } else if(strncmp(cmd,"all",3)==0){
   *chip= ~0;
   *prefix= 3;
 } else {
   Asagent_stderr(agent,"--- unknown option to -end_on : ",0);
   Asagent_stderr(agent,cmd,1);
   ret= 0;
   goto ex;
 }
 ret= 1;
ex:;
 return(ret);
}


int Asagent_set_end_on(agent,in_cmd,flag)
struct AsagenT *agent;
char *in_cmd;
int flag;
/*
 bit0= change value only if not already set
*/
{
 int ret=0,chip=0,prefix=0,timeout;
 char cmd[2*SfileadrL];

 strcpy(cmd,in_cmd);
 ret= Asagent_end_on_mask(agent,cmd,&chip,&prefix,0);
 if(ret<=0)
   goto ex;
 if(flag&1)
   if(agent->end_on_flag&chip)
     {ret= 2; goto ex;}
 agent->end_on_flag|= chip;
 if(cmd[prefix]!=0) {
   if(strcmp(cmd+prefix+1,"off")==0 || strcmp(cmd+prefix+1,"clear")==0) {
     agent->end_on_flag&= ~chip;
   }
   if(chip&(4|8)){
     if((agent->end_on_flag&chip)==0) 
       timeout= 0;
     else if(cmd[prefix+1]>='0' && cmd[prefix+1]<='9')
       sscanf(cmd+prefix+1,"%ld",&timeout);
     else 
       timeout= 3600;
     if(chip&4) {
       if(timeout>0)
         agent->end_on_timeout= time(0)+timeout;
       else
         agent->end_on_timeout= 0;
     }
     if(chip&8)
       agent->end_on_idle= timeout;
     Asagent_establish_alarm(agent,0);
     alarm(agent->end_on_timeout);
   }
   if(chip&16) {
     if(Sregex_string(&(agent->end_on_mark),cmd+prefix+1,0)<=0)
       {ret= -1; goto ex;}
   }
 }
 ret= 1;
ex:
 return(ret);
}

 
int Asagent_establish_alarm(agent,flag)
struct AsagenT *agent;
int flag;
/*
 bit2= do not consider end_on_timeout
 bit3= do not consider end_on_idle
*/
{
 int timeout= 0,current_time;

 current_time= time(0);
 if(!(flag&4))
   if((agent->end_on_flag&4) && agent->end_on_timeout>0 &&
      (timeout==0 || agent->end_on_timeout-current_time<timeout)) {
     timeout= agent->end_on_timeout-current_time;
     if(timeout==0)
       kill(getpid(),SIGALRM);
   }
 if(!(flag&8))
   if((agent->end_on_flag&8) && agent->end_on_idle>0 &&
      (timeout==0 || agent->end_on_idle<timeout))
     timeout= agent->end_on_idle;
 if(timeout<0)
   raise(SIGALRM);
 alarm(timeout);
 return(1);
}


int Asagent_check_end_on(agent,trigger,text,flag)
struct AsagenT *agent;
char *trigger;
char *text;
int flag;
{
 int ret,chip,prefix;

 ret= Asagent_end_on_mask(agent,trigger,&chip,&prefix,0);
 if(ret<=0)
   goto ex;
 if(chip & agent->end_on_flag) {
   if(chip&~16) 
     {ret= 1; goto ex;}
   if((chip&16) && strcmp(text,agent->end_on_mark)==0)
     {ret= 1; goto ex;}
 }
 ret= 0;
ex:
 return(ret);
}


int Asagent_is_local_cmd(agent,cmd,flag)
struct AsagenT *agent;
char *cmd;
int flag;
/*
 bit0= test concerning mark notification
*/
{
 int ret;
 char *cpt;

 if(strncmp(cmd,"-add_view",9)==0 && cmd[9]!=0)
   return(1);
 if(strcmp(cmd,"-end_client")==0)
   return(1);
 if(strcmp(cmd,"-end")==0 && (flag&1))
   return(1);
 if(strncmp(cmd,"-input_ready_fd:",16)==0)
   return(1);
 if(strncmp(cmd,"-internal",9)==0 && cmd[9]!=0)
   return(1);
 if(strncmp(cmd,"-mark",5)==0 && cmd[5]!=0) {
   cpt= strchr(cmd+6,':');
   if(cpt==NULL)
     return(1);
   ret= Asagent_is_local_cmd(agent,cpt+1,flag);
   return(ret);
 }
 if(strcmp(cmd,"-queue_canceled")==0 && (flag&1))
   return(1);
 if(strncmp(cmd,"-request",8)==0 && cmd[8]!=0) {
   cpt= strchr(cmd+9,':');
   if(cpt==NULL)
     return(1);
   ret= Asagent_is_local_cmd(agent,cpt+1,flag);
   return(ret);
 }
 if(strncmp(cmd,"-tcp_service",12)==0 && cmd[12]!=0)
   return(1);
 if(strncmp(cmd,"-user",5)==0 && cmd[5]!=0) {
   cpt= strchr(cmd+6,':');
   if(cpt==NULL)
     return(1);
   ret= Asagent_is_local_cmd(agent,cpt+1,flag);
   return(ret);
 }
 return(0);
}


int Asagent_execute_subcmd(agent,cmd,flag)
struct AsagenT *agent;
char *cmd;
int flag;
/*
 bit1= do not complain loudely about unknown command
 bit2= client mode
 bit3= forced local execution
 bit8= execute in request mode
*/
{
 int ret,encapsulate_views,request_mode,client_flag;

 if(cmd[0]==0) {
   agent->keep_views= 1;
   ret= 1;
   goto ex;
 }
 ret= Asevent_set_cmd(agent->event,cmd,0);
 if(ret<=0)
   goto ex;
 if(ret>0) {
   if(flag&256) {
     encapsulate_views= agent->encapsulate_views;
     request_mode= agent->request_mode;
     agent->encapsulate_views= 1;
     agent->request_mode= 1;
   }
   client_flag= 1;
   if(agent->service_mode==1)
     client_flag|= 4; 
   client_flag|= flag&(2|4|8);
   ret= Asagent_app_interpreter(agent,client_flag);
   if(flag&256) {
     agent->encapsulate_views= encapsulate_views;
     agent->request_mode= request_mode;
   }
   if(ret<0)
     goto ex;
 }
ex:;
 return(ret);
}


int Asagent_tcp_client(agent,servername,portnumber,
                        file_representation,encapsulation,flag)
struct AsagenT *agent;
char *servername;
int portnumber;
char *file_representation;
char *encapsulation;
int flag;
/*
flag:
 bit0= only open client state, do not enter loop nor close state
 bit1= only close client state
 bit2= bit1 of Asagent_clientloop() : be quiet

return values: 
  <=0 = error
  1 = all went normal
  3 = end agent service
*/
{
 int ret,disable_internal;
 char *cpt,cmdline[81];
 struct SconN *sconn= NULL;
 static char initcmd[]= {"-add_view:-:all:default"};
 static char cfdatacmd[]= {"-add_view:-:current_file:data"};
 static char dfdatacmd[]= {"-add_view:-:double_files:data"};
 static char newline[]= {"\n"};

 if(flag&2) {
   sconn= agent->client_sconn;
   disable_internal= agent->preclient_disable_internal;
   ret= 1; goto ex;
 }

 agent->preclient_disable_internal= disable_internal= agent->disable_internal;

 /* >>> check wether this is the own service address */
   /* >>> refuse to connect */

 ret= Sconn_tcpclient_new(&sconn,servername,portnumber,agent->access,0);
 if(ret<=0)
   goto ex;
 ret= Asqueue_sconn_to_inconn(agent->queue,5,sconn,0);
 if(ret<=0)
   goto ex;
 ret= Sconn_try_tunnel(sconn,0);
 if(ret<=0)
   goto ex;

 if(encapsulation!=NULL)
   sprintf(cmdline,"%s:%s\n",initcmd,encapsulation);
 else
   sprintf(cmdline,"%s\n",initcmd);
 ret= Sconn_write(sconn,cmdline,strlen(cmdline),0);
 if(ret<=0)
   goto ex;
 if(file_representation!=NULL) {
   if(strcmp(file_representation,"data")==0) {
     if(encapsulation!=NULL)
       sprintf(cmdline,"%s:%s\n",cfdatacmd,encapsulation);
     else
       sprintf(cmdline,"%s\n",cfdatacmd);
     ret= Sconn_write(sconn,cmdline,strlen(cmdline),0);
     if(ret<=0)
       goto ex;
     if(encapsulation!=NULL)
       sprintf(cmdline,"%s:%s\n",dfdatacmd,encapsulation);
     else
       sprintf(cmdline,"%s\n",dfdatacmd);
     ret= Sconn_write(sconn,cmdline,strlen(cmdline),0);
     if(ret<=0)
       goto ex;
   }
 }
 agent->disable_internal|= 3;             /* disable internal image viewers */
 Sconn_destroy(&(agent->client_sconn),0);
 agent->client_sconn= sconn;
 if(flag&1) {
   agent->service_mode= 1;
   return(1);
 }
 ret= Asagent_clientloop(agent,(flag&4)>>1);
 if(ret<=0)
   goto ex;
 if(ret==3)
   goto ex;
 ret= 1;
ex:;
 if(ret==3 || !(agent->loop_return_on_idle)) {
   agent->service_mode= 0;
   Asqueue_destroy_inconn(agent->queue,Sconn_get_fd(sconn,0),0);
   agent->client_sconn= NULL;
   Sconn_destroy(&sconn,0);
 }
 if(ret<=0)
   Asagent_consume_messages(agent,0);
 agent->disable_internal= (agent->disable_internal&~3)|(disable_internal&3);
 return(ret);
}


int Asagent_helptext(agent,reply,flag)
struct AsagenT *agent;
char **reply;
int flag;
/*
 bit0-3 = mode : 0=intro , 1=command reference , 2=appendice , 
                 3=external helpers , 4=key map help text 
*/
{
 static Asagent_helplinE intro_text[]= {
"",
"Commands usually are not toggled in but triggered by shortcut keys or sent",
"by external frontend programs.",
"To get a command line prompt, press the '@' key.",
"",
"If commands come faster than they can be processed, they get buffered and",
"executed as soon as possible. The ESC key discards all pending commands",
"and all those keystrokes and commands which follow the ESC immediately.",
"Please note that a lot of special keys produce sequences with ESC and",
"therefore cannot be used for key binding up to now.",
"",
"Commands are bound to single keys by option -keyset which takes a single",
"keyset statement as parameter.",
"See below command -keyset and the sample keyset definition.",
"",
"External frontend programs can connect via TCP/IP or named pipes.",
"They may send commands and apply for notification of any output event.",
"See below -pipe_service , -tcp_service, -add_view , -show_copy .",
"This software itself is able to act as such a frontend program via TCP/IP.",
"The connection may be encrypted to be secure against malicious clients",
"or third party interference. See below -security and -tcp_client .",
"",
"Unencrypted, the input protocol simply consists of command lines separated",
"by CR+LF, LF or NUL bytes. Several classes of output messages may be",
"subscribed by -add_view .",
"",
"",
"@END_OF_HELPTEXT_(HOPEFULLY_A_UNIQUELY_SILLY_TEXT)@"
};
 static Asagent_helplinE reference_text[]= {
"",
"                   Command reference of agent commands",
"",
"#text or !text",
"     Remarks. They are ignored like empty commands.",
"",
":character",
"     Same as  -synthetic:-1:1:character  (see below)",
"",
"-add_view:connection:subscription:representation[:encapsulation]",
"     Subscribe to a class of output events. This is the way how frontend",
"     programs get informations. There are several kinds of subscriptions:",
"       prompt             get notified when the server is idle and when it",
"                          becomes busy.",
"       stdout             get texts which are directed to standard output",
"       stderr             get texts which are directed to standard error",
"       current_file       get the current file (usually its name)",
"       double_files       get the list of possibly double files",
"       current_file_copy  get the copy of the current file (see -show_copy)",
"       double_files_copy  get the list of copies of possibly double files",
"       ask                get questions",
"       mark               get start and end of command -mark.",
"       reply              get start and end of command -request.",
"       all                subscribe to all output events",
"     Any time this program (the server) changes one of the subscribed states",
"     it sends a notification to the client using the chosen representation.",
"     The connection parameter may be a filename or a \"-\" character. A \"-\"",
"     tries to use an already established back channel to the frontend",
"     program. This will fail if the input connection is a pipe and no",
"     filename was given with a previous -add_view: from that client.",
"     It is ok to use a connection filename several times from within the",
"     same frontend program.",
"     The representation should be \"default\" up to now.",
"     If encapsulation is given as \"encapsulated\" then the view will only",
"     receive notifications caused by commands from the same input connection",
"     as this -add_view command. If encapsulation is set to \"open\" any",
"     command's output may be received.",
"     This setting applies to all subscriptions of the same view id (see",
"     below Appendix B, notification \"init\").", 
"     There are two subscriptions which are served automatically together",
"     with any other subscription:",
"       init           notifies that about the first subscription which is",
"                      assigned to a backchannel.",
"       end            notifies that the backchannel will be closed by the",
"                      server now (e.g. because it ends service).",
"     Also the subscriptions  mark  and  reply  are served as soon as any",
"     subscription is made. These notifications emerge from commands -mark",
"     and -request.",
"     The format of notification messages is described in appendix B.",
"",
"-arguments_to_queue",
"     Only in effect for commands given as program arguments. Usually the",
"     arguments are interpreted before the input for dialog is started.",
"     This prevents unwanted outside interaction during setup.",
"     By -arguments_to_queue all following arguments are placed in the input",
"     buffer. So they get executed as user commands from internal input as",
"     soon as dialog service starts.",
"     For automated start of -tcp_client it is desirable that all following",
"     arguments are sent to the server rather than waiting for the end of",
"     client mode. Use:  -arguments_to_queue -tcp_client:... ...",
"",
"-ask_end",
"     Ask for Y or N . End program if answer is Y.",
"",
"-bundle:mode",
"     After the command  -bundle:start  all following commands from the same",
"     input channel are buffered and their execution is delayed until the",
"     command  -bundle:end  or again  -bundle:start  is received.",
"     The execution of the buffered commands will not be mixed with commands",
"     from other channels. So one can rely that a combination of -jump and",
"     -moveto will really move the desired file even if a lot of other",
"     clients are using the server without any coordination.",
"     Be aware that the total size of buffered commands per channel is",
"     limited (but at least 64 KB ).",
"     -bundle may not be prepended by any other command (e.g. -mark).",
"",
"-double_check:mode",
"     In applications which show a current image item, a picture recognition",
"     check may be performed to find very similar images. This command",
"     wether such a test shall be performed by appropriate applications.",
"     Mode \"off\" disables the check, \"on\" performs it with any current",
"     image item. Mode \"auto\" allows the application to check only those",
"     images, which are not already under the management of the recognition",
"     system.",
"",
"-encapsulate_views:switch",
"     If switch is set to \"on\" this command excludes other views from",
"     being notificated about the effects of commands. Only the internal",
"     output channels (see -internal) and the views of the command's sender",
"     will get these notifications. This mode is useful if the clients of this",
"     program are not aware about each other and would interfere with their",
"     replies.",
"     \"off\" is the normal mode where all subscribers get all subscribed",
"     notifications.",
"",
"-end",
"     End the run of the program.",
"",
"-end_client",
"     Ends client mode. This mode eventually was initiated by -tcp_client .",
"",
"-end_on:trigger[:option]",
"     Set or delete trigger for automatic end of program. The trigger is",
"     deleted if option is 'clear' .",
"     Triggers defined up to now:",
"        list_end     is true if the current item cannot be set because the",
"                     end of the file list has been reached.",
"        prompt       (only effective in client mode) is true if the server",
"                     indicates to be idle by a 'prompt' notification.",
"        timeout      is true after the number of seconds given by option",
"                     has elapsed without a new -end_on:timeout.",
"        idle         is true after the number of seconds given by option",
"                     has elapsed without receiving an input event.",
"     A general trigger is defined which combines all triggers.",
"        all          is true if any trigger is true.",
"     Therefore -end_on:all:clear deletes all triggers.",
"",
"-end_server",
"     Sends an -end command to the server and ends client mode. This command",
"     is ignored if the program is not in client mode.",
"",
"-help[_short]",
"     Print this text. -help_short only prints the keyset help text.",
"     The program ends without any dialog if -help is its last argument.",
"",
"-input_ready_fd:code",
"     In client mode, this command notifies that data is available from",
"     the server. In normal (server) mode, this command is ignored.",
"",
"-internal:channelname:switch",
"     Enable or disable internal i/o channels. Available channel names are:",
"       current_file      the internal viewer for current files",
"       double_files      the internal viewer for possibly double files",
"       stdout            texts directed to standard output",
"       stderr            texts directed to standard error",
"       termios           listen for single character terminal input",
"       all               all of the above channels",
"     Switch may be either \"on\" or \"off\". Default is \"all:on\".",
"",
"-keyset:statement",
"     Manipulate the keyset mapping from single keystrokes to commands.",
"     A statement consists of a code word and possibly additional text.",
"     See also the example keyset definition below.",
"     Keyset statements:",
"       clearall             Clears the whole keyset.",
"       clear:keys@          Clears the mappings for one or more keys.",
"       clear:#code@         Clears the mapping for a key by its decimal code.",
"       helpstart:text       Clears the short helptext and adds first line.",
"       helpmore:text        Adds another line to short help text.",
"       maindir:address      Sets a common parent directory for file",
"                            addresses with 'map' and 'trashdir' which do not",
"                            begin with '/'.",
"                            Performs parameter substition.",
"       map:keys@command     Maps one or more single keys to a single command.",
"                            Use the same commands as for the command line but",
"                            no remarks.",
"       map:@#code@command   Maps a key by its decimal ASCII code to command.",
"       readfrom:filename    Reads keyset statements from a file one statement",
"                            per line. See example below.", 
"                            Performs parameter substition.",
"       trashdir:address     Sets the directory which keeps old file versions",
"                            for the -undo command.",
"                            Performs parameter substition.",
"       #text or !text       Remarks. They are ignored like empty statements.",
"     '@' (ASCII 64) and ESC (ASCII 27) cannot be mapped at all.",
"     If a key gets more than one mapping, then all these commands get",
"     executed in the same sequence as they have been mapped to the key.",
"     So if a key is to be newly defined, \"clear:\" should be applied first.",
"     Mapping for multi character keys (like F1) is not possible yet.",
"     Leading blanks before the code word (e.g. 'map') are ignored.",
"     Blanks between @ and 'command' are ignored. All other characters up to",
"     the line end are significant.",
"",
"-make_userkey:connectiontype:username",
"     Convert a file into an encrypted keyfile suitable for secure",
"     connections. The connectiontype may be one of:",
"       \"tcp\",\"file\",\"internal\",\"all\" .",
"     It is used to determine the keydirectory which may be set by -security.",
"     Within the keydirectory there has to be a file {username}.tnl with at",
"     least 64 bytes of content. The first 64 bytes are condensed and",
"     encrypted into a 16 byte key which replaces the original file content.",
"     Permission to read or write the file is granted only to the owner.",
"",
"-mark:id:command",
"     Notify the sender about start of command, execute command and notify",
"     about the end directly before the program checks for the next command.",
"     Other clients will not see the mark notifications.",
"     Note: the command -bundle will not work as argument of -mark.",
"",
"-permission:username:class[-action]:[\"permit\"|\"deny\"]",
"     Set a rule to permit or deny execution of particular actions by",
"     particular users. As soon as the dialog mode starts, the rules are",
"     checked with the effective username whenever a command requests a",
"     program action. Be careful with this command in dialog mode since you",
"     might exclude yourself from entering the next rule.",
"     The effective username is obtained from the authentication of the",
"     command's input connection. If no authentication by encryption has",
"     been enabled at that connection, the username is \"external_anonymous\"",
"     for external programs and \"internal_owner\" for program arguments",
"     and input at stdin.",
"     Username \"all\" in a rule applies to any effective user.",
"     Any action belongs to a class (like \"shell\" or \"move\") but may",
"     also be addressed individually. The youngest matching rule applies.",
"     Example (deny shell commands for any user other than \"internal_owner\"",
"              but allow the use of a particular script with current item):",
"       -permission:all:shell:deny",
"       -permission:internal_owner:shell:permit",
"       -permission:all:shell-/home/scripts/infoscript $*:permit",
"     For a complete list of classes, see appendix agent P below",
"",
"-pipe_service:type:filename",
"     Create filename as named pipe and listen for input. The parameter type",
"     determines how the input shall be used :",
"       1= handle single bytes as keystrokes.",
"       2= handle text lines as commands.",
"       3= send text lines to stdout",
"       4= send text lines to stderr",
"     For frontend programs only type 2 is useful. Type 1 is discouraged.",
"     If filename already exists and is a regular file, it gets replaced by",
"     the named pipe. The named pipe is removed when it is closed.",
"     Usually the first action of a frontend program is to send a -add_view",
"     command with the name of the pipe for output.",
"",
"-preserve_orphan_events:mode",
"     When a client connection ends, usually the server removes from the",
"     input queue all pending events which originate from that client.",
"     This is the default mode \"off\". If the server shall execute commands",
"     from clients which do not wait for completion, the mode may be set ",
"     to \"on\".", 
"     Due to the compex handling of such orphan events, \"on\" is discouraged",
"     in high security environments.",
"",
"-queue_canceled",
"     In client mode this causes a ESC line to be sent to the server.",
"     In normal (server) mode, this command is ignored.",
"",
"-readfrom:fileaddress",
"     Read lines from file and execute each one as command.",
"     Performs parameter substition.",
"",
"-refresh",
"     Redisplay the current item and eventually its lookalikes. Also print",
"     again the file information lines.",
"",
"-repair_icv:statement",
"     Set or delete trigger for automatic conversion which cause the internal",
"     current view process to exit with nonzero value. This happens mostly if",
"     the format of the imagefile is not known to the viewer program.",
"     There are two possible statements:",
"        on .... if the viewer exits badly, try to repair the file via -jpgb",
"        off ... do not try to repair the file",
"",
"-request:id:command",
"     Notify the sender about start of command, execute command and notify",
"     about the end directly after the command itself ended. Text messages to",
"     standard output will only be delivered to the sender of -request.",
"     Other clients will not see the mark notifications. This is similar",
"     to -mark but the end notification will be sent more early.",
"     Note: the command -bundle will not work as argument of -request.",
"",
"-shell:shellcommand",
"     Execute a shell command.",
"     Performs parameter substition if the application supports it.",
"",
"-security:connectiontype:option:value",
"     Add an access rule to the security list for remote connections.",
"     The connectiontype may be one of: \"tcp\",\"file\",\"internal\",\"all\"",
"     Options may be:",
"       tunnel        controls encryption. Possible values are \"require\"",
"                     \"allow\" or \"refuse\" encryption.",
"       user          its value sets the username for encryption.",
"       keydirectory  its value sets the directory with the user key files.",
"       controller    controls access to the -security command. Initially",
"                     only \"internal\" connections (i.e arguments and",
"                     keyboard) are allowed to use this command.",
"                     By value \"on\" one may enable other connectiontypes",
"                     which then should have set \"tunnel:require\".",
"     If more than one rule matches, the youngest one is used.",
"",
"-show_copy:connection:subscription:options:target",
"     Subscribe to a copy-and-notification service for image files. Different",
"     from -add_view this subscription makes a copy of the files to be shown.",
"     Then it notifies its subscriber about the addresses of the copies.",
"     Any other subscribers of \"${subscription}_copy\" will get notified",
"     only if connection is \"*\". In this case -show_copy has no own back",
"     channel but relies on channels which have to be subscribed by -add_view.",
"     Other connection names are handled like in -add_view.",
"     Subscription may be one of :",
"       current_file       copy the current file",
"       double_files       copy the possibly double files",
"       all                all of the above",
"     Options may be a list of the following keywords and their eventual",
"     parameters:",
"      max_number=number  limits the number of copied files. This may be",
"                         be necessary for subscription \"double_files\".",
"      encapsulate        if this keyword is present, subscriptions are",
"                         encapsulated (see -add_view). Also the display of",
"                         copyfiles does end not before the next command from",
"                         the same input connection is received. Without this",
"                         keyword copyfiles end display as soon as the next",
"                         file is to be displayed.",
"      keep=seconds       copyfiles normally get removed when the subscribers",
"                         are notified about end of their display. They may",
"                         be kept available on the disk for the given number",
"                         of seconds. This is useful if serving for a web",
"                         server whose clients may need some time to load",
"                         the files.",
"     Target is a file address template. For an particular file it will be ",
"     extended by a unique counting number and the file name's dot extension.",
"     Example: target=/tmp/simv_current  , filename=/home/me/my_cat.jpg",
"              Name of copy:  /tmp/simv_current_1168105077.jpg",
"              This name is sent with a \"current_file_copy\" notification.",
"     Despite copyfiles get removed if all goes well, one should use a",
"     separate directory which is easy to clean from old remnant file copies.",
"     Just in case that something goes wrong.",
"",
"-synthetic:connection:type:text",
"     Create a synthetic input event. Useful to emulate a keystroke",
"     via a line oriented input connection. The value of \"connection\" has",
"     to be -1 up to now. \"type\" tells how to handle \"text\" :",
"         1=keystroke , 2=command line , 3 = to stdout, 4 = to stderr",
"",
"-tcp_client:hostname:portnumber[:representation:[encapsulation]]",
"     Enter client mode. This means to connect to a peer program and to",
"     subscribe for all output events. Most of the input events will be",
"     forwarded to the peer and the incoming notifications will be",
"     printed and sent to the own frontend clients. The internal image",
"     viewers for current and double files are disabled though.",
"     The peer has to provide TCP/IP service by -tcp_service:hostname:...",
"     Commands that are handled locally:",
"        -add_view , -end , -end_client , -input_ready_fd , -internal",
"        -queue_canceled , -show_copy , -tcp_service", 
"     If a username has been set by  -security:tcp:user:...  then",
"     this name is used for for authentication and encryption.",
"     (see appendix C)",
"     If representation is \"data\" then the subscriptions for image files",
"     will cause the server to transmit the whole file contents together",
"     with their addresses. All subscriptions made by -show_copy at this",
"     client will make their file copy from the transmitted content rather",
"     than trying to read the file itself. If internal file viewers are",
"     enabled (by -internal after -tcp_client), then they show these file",
"     copies rather than trying to read the file itself.",
"     This notification method is helpful if direct file access is not",
"     possible due to access restrictions or due to incompatible file",
"     addressing (try: -show_copy:... -tcp_client:... -internal:all:on ).",
"     If encapsulation is given as \"encapsulated\" then the client will",
"     only receive notifications which are caused by its own commands.",
"     If encapsulation is \"open\" or missing, any command's results may",
"     be received.",
"",
"-tcp_service:type:hostname:portnumber:access_mask[:option]",
"     Offer service for frontend programs via TCP/IP. A client like telnet",
"     or a peer of this program itself (see -tcp_client) may connect to",
"     the address given by hostname and portnumber. Depending on the given",
"     type, input will be handeled differently:",
"       1= handle single bytes as keystrokes.",
"       2= handle text lines as commands.",
"       3= send text lines to stdout",
"       4= send text lines to stderr",
"     For frontend programs only type 2 is useful. Type 1 is discouraged.",
"     If portnumber is 0, the operating system will assign one automatically.",
"     The access_mask describes (in hex) which hosts other than localhost",
"     are allowed to connect. Connection is refused if :",
"       ( access_mask & foreign_address ) != ( access_mask & host_address )",
"     Where host_address is the address of hostname given with -tcp_service.",
"     Please note that this might be circumvented by IP-spoofing and that",
"     there is no check of user identity. Nevertheless the mask test provides",
"     a first defense against denial-of-service attacks."  ,
"     In hostile IT environments, use -security:tcp:tunnel:require  to demand",
"     user authentication and encrypted communication. See also appendix C .",
"     Examples: Serve at port 50000, do only accept connections from localhost",
"       -tcp_service:2:localhost:50000:FFFFFFFF",
"     Accept connections from own C-class net (assuming own hostname = ts4)",
"       -tcp_service:2:ts4:50000:FFFFFF00",
"     Accept from anywhere",
"       -tcp_service:2:localhost:50000:00000000",
"     If 'option' is given as \"obstinate\" the program will ignore errors",
"     with call bind() and try to obtain a server socket until it finally",
"     succeeds (or the program gets stopped).",
"",
"-user:username:command",
"     Require permission to execute command not only for the authenticated",
"     user but also for the one given by username.",
"",
"-viewer_cmd:shellcommand",
"     Set the shell command which starts an image viewing program. The program",
"     will be started to display one or more image files.",
"       ${shellcomand} -geometry [+|-]0+0 ${filename_1} ... ${filename_N}",
"     A geometry of +0+0 should create the image window at the upper left",
"     of the screen. -0+0 should do the same adjusted to the upper right.",
"     Tested shellcommands on Linux : xv , display", 
"@END_OF_HELPTEXT_(HOPEFULLY_A_UNIQUELY_SILLY_TEXT)@"
};
 static Asagent_helplinE appendice_text[]= {
"",
"",
"                      Appendix agent A :  Keyset Definitions",
"",
"Usually a keyset definition is written to a file and read by -keyset:readfrom",
"There are only few sagent commands which make sense with keys, so better look",
"at Appendix application A for a more realistic example.",
"",
"If the content of file /home/me/sagentkeys looks like that:",
"",
"  # Clear old keyset",
"    clearall",
"",
"  # Some helptext",
"    help: -disable_text  +enable_text  ?help  Quit",
"  # disable output of text",
"    map:-@     -internal:stdout:off",
"    map:-@     -internal:stderr:off",
"  # enable output of text",
"    map:+@     -internal:stdout:on",
"    map:+@     -internal:stderr:on",
"  # The help key",
"    map:?@     -help_short",
"  # Ask wether the program shall end",
"    map:Qq@    -ask_end",
"",
"then the command",
"  -keyset:readfrom:/home/me/sagentkeys",
"activates this definition and overwrites the old one.",
"",
"",
"              Appendix agent B : Format of Notification Messages",
"",
"A notification is a message consisting of a header and some fields.",
"It is terminated by a linefeed although it may contain 8-bit data.",
"  subscription number_of_fields [field[...field]]\\n",
"A field consists of its (printable) header and a 8-bit data part :",
"  :name:representation:number_of_bytes:bytes",
"Example:",
"  current_file 2 :idx:data:1:5:file1:address:20:/usr/pictures/me.jpg\\n",
"                 |first field||---------- second field ------------|",
"",
"Message format of particular subscription notifications.",
"{#} is the number_of_bytes in decimal.",
"For better readability, each field is shown in a separate line.",
"",
"When the server encounters the first subscription of a client :",
"  init 1 :id:data:{#}:{id-number}\\n",
"This message is also generated by every single -show_copy subscription.",
"When the server ends service, for every \"init\" it issues an \"end\" :",
"  end 1 :id:data:{#}:{id-number}\\n",
"",
"Message to standard output resp. standard error :",
"  stdout 1 :text:data:{#}:{text}\\n",
"  stderr 1 :text:data:{#}:{text}\\n",
"",
"When a file is added to the list",
"  list_change 3 :idx:data:{#}:{index}",
"                :action:data:6:append:",
"                :item:data:{#}:{filename}\\n",
"When the filename of a list item changes, \"action\" is set to \"change\"",
"  list_change 3 :idx:data:{#}:{index}",
"                :action:data:6:change:",
"                :item:data:{#}:{filename}\\n",
"",
"When the current file gets displayed by the internal viewer :",
"  current_file 2 :idx:data:{#}:{index}",
"                 :file1:address:{#}:{filename}\\n",
"or if subscribed with representation \"data\" :",
"  current_file 3 :idx:data:{#}:{index}",
"                 :file1:address:{#}:{filename}",
"                 :content1:data:{#}:{filecontent}\\n",
"When the current file ends to be displayed :",
"  current_file 0 \\n",
"If two possibly similar images were found by the recognition system :",
"  double_files 2 :file1:address:{#}:{name1}",
"                 :file2:address:{#}:{name2}\\n",
"or (if subscribed by representation \"data\")",
"  double_files 4 :file1:address:{#}:{name1}",
"                 :content1:data:{#}:{content1}",
"                 :file2:address:{#}:{name2}",
"                 :content2:data:{#}:{content2}\\n",
"When the display of these similar images ends :",
"  double_files 0 \\n",
"The same formats are used for subscriptions \"current_file_copy\" and",
"\"double_files_copy\" (see -show_copy).",
"",
"When the server becomes idle :",
"  prompt 2 :idx:data:{#}:{index}",
"           :count:data:{#}:{total_files}\\n",
"When it gets busy :",
"  prompt 0 \\n",
"",
"When a question is asked :",
"  ask 4 :id:data:{#}:{question_id}",
"        :type:data:{#}:{type}",
"        :text:data:{#}:{question_text}",
"        :constraint:data:{#}:{rules}\\n",
"When the question has been answered :",
"  ask 4 :id:data:{#}:{question_id}",
"        :type:data:6:cancel",
"        :text:data:0:",
"        :constraint:data:0:\\n",
"",
"Output is done by the particular commands as well as by the command loop",
"which informs about the command before and possibly about the current item",
"after execution. The command -request surroundis exactly the command's",
"output and does not include any loop output. The command -mark surrounds",
"everything after \"prompt 0\" up to and including \"prompt 2 ...\".",
"",
"Before a command given with -mark is executed:",
"  mark 2 :state:data:5:start",
"         :id:data:{#}:{id given with -mark}\\n",
"Before the program checks for the next input event after -mark",
"  mark 2 :state:data:3:end",
"         :id:data:{#}:{id given with -mark}\\n",
"",
"Before a command given with -request is executed:",
"  reply 2 :state:data:5:start",
"          :id:data:{#}:{id given with -request}\\n",
"After the command has been executed:",
"  reply 2 :state:data:3:end",
"          :id:data:{#}:{id given with -request}\\n",
"",
"One can explore the notifications by telnet. Connect to the server",
"(enabled by -tcp_service) and send:  -add_view:-:all:default",
"Then operate the server via its usual interface and watch the messages",
"received by telnet. One also may send command lines from telnet.",
"",
"",
"             Appendix agent C : Authentication and Encryption",
"",
"Connections between the program and its frontends may be made secure by",
"a user-related 128-bit encryption key. A user's key is stored in a file",
"within a keydirectory which is known to the program. The file's name is the",
"user's name extended by .tnl . Anybody who is able to read that file is",
"authorized to connect under that user identity. Therefore, restrictive",
"access permissions should be set for that file.",
"",
"By help of command -security one can set the keydirectory, the security",
"requirements of a server and the username for use with -tcp_client.",
"The particular connection types may have separate settings.",
"",
"The content of a user's keyfile is encrypted by the internal key of the",
"program. Since this key may vary from installation to installation, it",
"is better to use -make_userkey rather than creating the keyfile by other",
"means. Create an original 64-byte file of random bytes, transport it and",
"convert it locally.",
"",
"If a user's keyfile has been installed at both hosts, it is sufficient to",
"allow encryption at the server side and to set a user for type \"tcp\" on",
"the client side. When client mode starts (by -tcp_client) the necessary",
"handshake is performed automatically between server and client.",
"",
"Default security settings are :",
"   -security:all:tunnel:refuse",
"   -security:all:controller:off",
"   -security:tcp:tunnel:allow",
"   -security:internal:controller:on",
"   -security:all:keydirectory:${HOME}/tnl_dir",
"Remember: the youngest matching rule wins. So encryption is only allowed for",
"TCP/IP connections and security controlling is only allowed for internal",
"input (program arguments and termios/stdin at the start terminal).",
"So usually one only has to set a username before connecting to the server.",
"   -security:all:user:{username}",
"   -tcp_client:{hostname}:{portnumber}",
"",
"",
"               Appendix agent L : Legal stuff",
"",
"This software is copyright 2001, Thomas Schmitt stic-source@gmx.net and",
"provided to you without any warranty under an open source BSD license.",
"(see file COPYING)",
"",
"",
"                Appendix agent P : Permission Classes",
"",
"Any action caused by a command is checked against rules which may have been",
"defined by the command -permission . A rule may address a whole class or a",
"single action. Depending on the command, more than one action may take place.",
"The application command",
"   -moveto:$(/home/scripts/find_target $*)",
"first tests for",
"   class=\"move\"  , action=\"moveto\"",
"and then for",
"   class=\"shell\" , action=\"/home/scripts/find_target $*\"",
"Nearly all commands test for their class and name, but -shell execution tests",
"for class \"shell\" and the shell command before parameter substition takes",
"place. The command -user tests for class \"user\" and the given username.",
"",
"  Class       Command (resp. Action)",
"------------------------------------------------------------------------",
"  security    -security , -make_userkey , -permission, -viewer_cmd",
"  shell       -{shell command before parameter substitution}",
"  end         -ask_end , -end , -end_client , -end_on , -end_server",
"",
"  service     -double_check , -encapsulate_views , -internal , -keyset ",
"              -pipe_service , preserve_orphan_evenets , -show_copy",
"              -tcp_client , -tcp_service",
"",
"  cancel      -queue_canceled",
"",
"  user        -(username given with command -user)",
"  client      -add_view , -bundle , -mark , -request , -synthetic",
"  script      -readfrom",
"  help        -help",
"",
"For application specific commands, see the appropriate appendix P.",
"",
"Special care should be taken for class \"shell\". If permitted, the commands",
"are executed under the user id which started this program. Class \"security\"",
"should be even more restricted to avoid unauthorized changes of permissions.",
"",
"Note that  -permission:all:security:deny  is quite final in dialog. You",
"will get no chance to enter further -permission commands. So, only if given",
"in the program's start arguments, a set of rules may begin like that :",
" -permission:all:security:deny \\",
" -permission:all:shell:deny \\",
"Control terminal and program arguments get administrator permissions :",
" -permission:internal_owner:security:permit \\",
" -permission:internal_owner:shell:permit \\",
"",
"Others are allowed to perform some selected shell commands :",
" -permission:all:shell-/home/scripts/infoscript $*:permit",
" -permission:all:shell-/home/scripts/automatic_move_target $*:permit",
"",
"For a quite mistrusted user \"webserver\" one may additionally define :",
" -permission:webserver:all:deny",
" -permission:webserver:client:permit",
" -permission:webserver:navigation:permit",
" -permission:webserver:help:permit",
" -permission:webserver:info:permit",
"from class \"modify\" we only allow action -repair_icv:",
" -permission:webserver:modify-repair_icv:permit",
"",
"@END_OF_HELPTEXT_(HOPEFULLY_A_UNIQUELY_SILLY_TEXT)@"
};
 Asagent_helplinE *helptext;
 int mode,ret,i;
 char line[SfileadrL];

 if(Sregex_string(reply,"",0)<=0)
   {ret= -1; goto ex;};
 mode= flag&15;
 if(mode==0)
   helptext= intro_text;
 else if(mode==1)
   helptext= reference_text;
 else if(mode==2)
   helptext= appendice_text;
 else if(mode==3)
   goto external_helpers;
 else if(mode==4)
   goto keymap;
 else
   {ret= 0; goto ex;} 
 for(i=0;strcmp(helptext[i],
                "@END_OF_HELPTEXT_(HOPEFULLY_A_UNIQUELY_SILLY_TEXT)@"
                )!=0;i++) {
   sprintf(line,"%s\n",helptext[i]);
   if(Sregex_string(reply,line,1)<=0)
     {ret= -1; goto ex;};
 }  
 ret= 1; goto ex;

external_helpers:;
 if(Sregex_string(reply,"Image viewer               :  ",0)<=0)
   {ret= -1; goto ex;};
 if(Sregex_string(reply,agent->view_prototype->cmd,1)<=0)
   {ret= -1; goto ex;};
 if(Sregex_string(reply,"\nTextual file information   :  ls -l",1)<=0)
   {ret= -1; goto ex;};
 if(Sregex_string(reply,"\n",1)<=0)
   {ret= -1; goto ex;};
 ret= 1; goto ex;

keymap:;
 if(Sregex_string(reply,agent->queue->input->prog->helptext,1)<=0)
   {ret= -1; goto ex;};
 ret= 1; goto ex;

 ret= 1;
ex:;
 return(ret);
}


int Asagent_cmd_help(agent,flag)
struct AsagenT *agent;
int flag;
/*
 bit0= -help_short : display only Imvprog help text
*/
{
 int ret,i;
 char line[4096],*helptext= NULL;

 ret= Asagent_get_permission(agent,"help","help",0);
 if(ret<=0)
   goto ex;

 if(flag&1)
   goto help_short;

 Asagent_stdout(agent,"",1);
 Asagent_stdout(agent,"",1);
 Asagent_stdout(agent,"                Features and Options of ",0);
 Asagent_stdout(agent,agent->progname,1);

 for(i=0;i<3;i++) {
   ret= Asagent_helptext(agent,&helptext,i);
   if(ret<=0)
     goto ex;
   Asagent_stdout(agent,helptext,4);
 }
 Asagent_stdout(agent,"",1);
 Asagent_stdout(agent,
"----------------------------- External helper programs ------------------------",
                 1);
 Asagent_stdout(agent,"",1);
 ret= Asagent_helptext(agent,&helptext,3);
 if(ret<=0)
   goto ex;
 Asagent_stdout(agent,helptext,0);
 Asagent_stdout(agent,"",1);
 Asagent_stdout_bar(agent,1);
help_short:;
 ret= Asagent_helptext(agent,&helptext,4);
 if(ret<=0)
   goto ex;
 Asagent_stdout(agent,"",1);
 Asagent_stdout_bar(agent,1);
 Asagent_stdout(agent,helptext,1);
 Asagent_stdout_bar(agent,1);
 ret= 1;
ex:
 Sregex_string(&helptext,NULL,0);
 return(ret);
}


int Asagent_cmd_readfrom(agent,in_adr,connection,username,flag)
struct AsagenT *agent;
char *in_adr;
int connection;
char *username;
int flag;
/*
 return:
 <=0 : error
   1 : ok
   3 : end agent service
*/
{
 int ret;
 FILE *fp=NULL;
 char line[SfileadrL*2],*fret,*adr= NULL;

 if(agent==NULL)
   return(0);

 ret= Asagent_get_permission(agent,"script","readfrom",0);
 if(ret<=0)
   goto ex;
 ret= Asagent_eval(agent,in_adr,&adr,0);
 if(ret<=0)
   goto ex;
 fp= Sfile_fopen(adr,"r",0);
 if(fp==NULL)
   {ret= 0; goto ex;}
 while(1){
   fret= Sfile_fgets(line,sizeof(line),fp);
   if(fret==NULL)
 break;
   if(line[0]==0||line[0]=='#'||line[0]=='!')
 continue;
   Asevent_destroy(&(agent->event),0);
   ret= Asevent_new(&(agent->event),line,connection,username,0);
   if(ret<=0)
     goto ex;
   ret= Asagent_app_interpreter(agent,1);
   if(ret<=0)
     goto ex;
   if(ret==3)
     goto ex;
 }
 ret= 1;
ex:;
 Sregex_string(&adr,NULL,0);
 if(fp!=NULL)
   fclose(fp);
 return(ret);
}


int Asagent_cmd_shell(agent,in_cmd,flag)
struct AsagenT *agent;
char *in_cmd;
int flag;
{
 int ret,status;
 char *cmd= NULL; 

 ret= Asagent_get_permission(agent,"shell",in_cmd,0);
 if(ret<=0)
   goto ex;
 ret= Asagent_eval(agent,in_cmd,&cmd,1);
 if(ret<=0)
   goto ex;
 Asagent_stdout(agent,"",1);
 Asagent_stdout(agent,
     "#####################################################################",1);
 Asagent_stdout(agent,cmd,1);
 Asagent_stdout(agent,
     "=====================================================================",1);
 Asagent_shell(agent,cmd,&status,0);
 Asagent_stdout(agent,
     "#####################################################################",1);
 ret= 1;
ex:;
 Sregex_string(&cmd,NULL,0);
 return(ret);
}


int Asagent_cmd_pipe_service(agent,in_cmd,flag)
/* warning: replaces regular files by temporary pipes */
struct AsagenT *agent;
char *in_cmd;
int flag;
/*
 bit0= do not allow use of existing files
 bit1= try to find a non existing name if bit0 would cause an error
 bit2= if necessary to create a fifo, make it permanent
 bit8= do not remove existing regular files but use them
*/
{
 int ret,type,fd= -1,filetype,keep_pipe_alive_fd;
 char *filename= NULL,*cpt;

 ret= Asagent_get_permission(agent,"service","pipe_service",0);
 if(ret<=0)
   goto ex;

 /* read :  type:filename  */
 cpt= in_cmd;
 ret= Sregex_cut_neck_int(cpt,':',&type,&cpt,0);
 if(ret<0)
   goto ex;
 if(ret==2 || strlen(cpt)==0) {
   Asagent_stderr(agent,"no pair type:filename found in  -pipe_service:",0);
   Asagent_stderr(agent,in_cmd,1);
   ret= 0;
   goto ex;
 }
 ret= Sregex_string(&filename,cpt,0);
 if(ret<=0)
   goto ex;

 if(type<1 || type>4) {
   Asagent_stderr(agent,"illegal type in  -pipe_service:",0);
   Asagent_stderr(agent,in_cmd,1);
   ret= 0;
   goto ex;
 }
 type|= (1<<12);

 /* >>> check wether file exists */
 filetype= Sfile_type(filename,1);
 if(filetype==-1 || (filetype==1 && !(flag&8))) {
   ret= Sfile_make_fifo(filename,(filetype==1)<<8);
   if(ret<=0) {
     Asagent_stderr(agent,"error occured while creating named pipe ",0);
     Asagent_stderr(agent,filename,1);
     Asagent_stderr(agent,"   ",0);
     Asagent_stderr(agent,strerror(errno),0);
     ret= 0;
     goto ex;
   }
   if(!(flag&4))
     type|= (1<<13); /* mark for deletion on close */
 } else if(flag&1) {
   if(flag&2) {

     /* >>> try to find a better name */;

   } else {
     Asagent_stderr(agent,"file object already exists in  -pipe_service:",0);
     Asagent_stderr(agent,in_cmd,1);
     ret= 0;
     goto ex;
   }  
 } else if(filetype==2) {
   Asagent_stderr(agent,"directory name given in  -pipe_service:",0);
   Asagent_stderr(agent,in_cmd,1);
   ret= 0;
   goto ex;
 }

 fd= open(filename,O_RDONLY|O_NONBLOCK,0);
 if(fd==-1) {
   Asagent_stderr(agent,"error occured while opening file ",0);
   Asagent_stderr(agent,filename,1);
   Asagent_stderr(agent,"   ",0);
   Asagent_stderr(agent,strerror(errno),0);
   ret= 0;
   goto ex;
 }
 keep_pipe_alive_fd= open(filename,O_WRONLY|O_NONBLOCK);
 ret= Asqueue_new_inconn(agent->queue,type,filename,fd,keep_pipe_alive_fd,0);
 if(ret<=0)
   goto ex;
 agent->keep_views= 1;
 ret= 1;
ex:;
 Sregex_string(&filename,NULL,0);
 return(ret);
}


int Asagent_cmd_tcp_service(agent,in_cmd,flag)
struct AsagenT *agent;
char *in_cmd;
int flag;
{
 int ret,portnumber,type;
 unsigned long external_s_mask;
 char *servername= NULL,*cpt,*option= NULL;
 char line[2*Stcp_strL];
 static char typetext[3][40]={"","single character","line oriented"};
 struct StcpserV *serv;

 ret= Asagent_get_permission(agent,"service","tcp_service",0);
 if(ret<=0)
   goto ex;

 if(Sregex_string(&servername,"localhost",0)<=0)
   {ret= -1; goto ex;}
 portnumber= 0;
 external_s_mask= 0xFFFFFFFF;
 type= 2;
 if(Sregex_string(&option,"",0)<=0)
   {ret= -1; goto ex;}

 /* read :  type:servername:port:external_s_mask   */
 cpt= in_cmd;
 ret= Sregex_cut_neck_int(cpt,':',&type,&cpt,0);
 if(ret<0)
   goto ex;
 if(ret==2 || strlen(cpt)==0)
   goto start_serv;
 ret= Sregex_cut_neck(cpt,':',&servername,&cpt,0);
 if(ret<0)
   goto ex;
 if(ret==2 || strlen(cpt)==0)
   goto start_serv;
 ret= Sregex_cut_neck_int(cpt,':',&portnumber,&cpt,0);
 if(ret<0)
   goto ex;
 if(ret==2 || strlen(cpt)==0)
   goto start_serv;
 ret= Sregex_cut_neck_int(cpt,':',&external_s_mask,&cpt,1);
 if(ret<=0)
   goto ex;
 if(ret==2 || strlen(cpt)==0)
   goto start_serv;
 ret= Sregex_cut_neck(cpt,':',&option,&cpt,1);
 if(ret<=0)
   goto ex;
 if(ret==2 || strlen(cpt)==0)
   goto start_serv;
 Asagent_stderr(agent,"  trailing parameters ignored with -tcp_service: ",0);
 Asagent_stderr(agent,cpt,1);

start_serv:;
 ret= Asqueue_start_tcpserv(agent->queue,servername,portnumber,
                             external_s_mask,type,0);
 if(ret<=0) {
   sprintf(line,"\n--- failed to start %s TCP/IP service at :\n",
                typetext[type]);
   sprintf(line+strlen(line),"%s  port %ld\n\n",servername,portnumber);
   Asagent_stderr(agent,line,1);
   if(strcmp(option,"obstinate")!=0)
     goto ex;
   Asagent_stderr(agent,"option 'obstinate' set. will retry in 30 seconds",1);
   sleep(30);
   goto start_serv;
 }
 Asqueue_get_tcpserv(agent->queue,type,&serv,0);
 portnumber= serv->portnumber;
 sprintf(line,"\n%s TCP/IP service started at :\n",typetext[type]);
 sprintf(line+strlen(line),"  %s (0x%-8.8X)    port %ld    mask 0x%-8.8X\n\n",
         servername,serv->external_s_addr,portnumber,external_s_mask);
 Asagent_stdout(agent,line,1);
 agent->keep_views= 1;
 ret= 1;
ex:;
 Sregex_string(&servername,NULL,0);
 Sregex_string(&option,NULL,0);
 return(ret);
}


int Asagent_cmd_end_on(agent,in_cmd,flag)
struct AsagenT *agent;
char *in_cmd;
int flag;
{
 int ret=0;

 ret= Asagent_get_permission(agent,"end","end_on",0);
 if(ret<=0)
   goto ex;
 ret= Asagent_set_end_on(agent,in_cmd,0);
 if(ret<=0)
   goto ex;
 agent->keep_views= 1;
ex:
 return(ret);
}


int Asagent_cmd_show_copy(agent,in_cmd,flag)
struct AsagenT *agent;
char *in_cmd;
int flag;
{
 int ret,copy_limit= 5,fd,filetype,i,retry=0,broadcast=0,keep_time= 0;
 int encapsulated= 0;
 char id[81],*cpt,*connection= NULL,*purpose= NULL,*copy_target= NULL;
 char *actual_purpose= NULL,line[81],*options= NULL,*opt;
 struct AsvieW *view= NULL,*old_view= NULL;
 static char all_list[][81]= {"current_file","double_files",""};

 ret= Asagent_get_permission(agent,"service","show_copy",0);
 if(ret<=0)
   goto ex;

 Asagent_del_broken_views(agent,0);

 /* parse: connection:purpose:options:copy_target */
 cpt= in_cmd;
 ret= Sregex_cut_neck(cpt,':',&connection,&cpt,0);
 if(ret<0)
   goto ex;
 if(ret==2 || strlen(cpt)==0) {
malformed:;
   Asagent_stderr(agent,"--- malformed options to -show_copy : ",0);
   Asagent_stderr(agent,in_cmd,1);
   ret= 0; goto ex;
 }
 ret= Sregex_cut_neck(cpt,':',&purpose,&cpt,0);
 if(ret<0)
   goto ex;
 if(ret==2 || strlen(cpt)==0) 
   goto malformed;
 ret= Sregex_cut_neck(cpt,':',&options,&cpt,0);
 if(ret<0)
   goto ex;
 opt= strstr(options,"max_number=");
 if(opt!=NULL)
   sscanf(opt+11,"%ld",&copy_limit);
 opt= strstr(options,"encapsulated");
 if(opt!=NULL)
   encapsulated= 1;
 opt= strstr(options,"keep=");
 if(opt!=NULL)
   sscanf(opt+5,"%ld",&keep_time);
 if(ret==2 || strlen(cpt)==0) 
   goto malformed;
 ret= Sregex_string(&copy_target,cpt,0);
 if(ret<=0)
   goto ex;
 if(connection[0]==0) 
   goto malformed;

 if(strcmp(purpose,"all")==0){
   for(i=0;all_list[i][0]!=0;i++){
     if(Sregex_string(&actual_purpose,connection,0)<=0)
       {ret= -1; goto ex;}
     if(Sregex_string(&actual_purpose,":",1)<=0)
       {ret= -1; goto ex;}
     if(Sregex_string(&actual_purpose,all_list[i],1)<=0)
       {ret= -1; goto ex;}
     if(Sregex_string(&actual_purpose,":",1)<=0)
       {ret= -1; goto ex;}
     if(Sregex_string(&actual_purpose,options,1)<=0)
       {ret= -1; goto ex;}
     if(Sregex_string(&actual_purpose,":",1)<=0)
       {ret= -1; goto ex;}
     if(Sregex_string(&actual_purpose,copy_target,1)<=0)
       {ret= -1; goto ex;}
     if(Sregex_string(&actual_purpose,"_",1)<=0)
       {ret= -1; goto ex;}
     if(Sregex_string(&actual_purpose,all_list[i],1)<=0)
       {ret= -1; goto ex;}
     ret= Asagent_cmd_show_copy(agent,actual_purpose,0);
     if(ret<=0)
       goto ex;
   }
   ret= 1;
   goto ex;
 }

 if(strcmp(connection,"*")==0) {
   fd= -1;
   filetype= -1;
   broadcast= 1;
 } else {
   ret= Asagent_obtain_fd_type(agent,connection,&fd,&filetype,0);
   if(ret<=0)
     goto ex;
   broadcast= 0;
 }
 ret= Asagent_make_view(agent,&view,"copy",filetype,connection,fd,broadcast);
 if(ret<=0)
   goto ex;
 view->encapsulated= encapsulated;

 /* look for an old "copy" view with same sconn, copy_target, purpose */
 retry= 0;
 while(1) {
   ret= Asagent_find_view(agent,&old_view,"copy","","",
                           Sconn_get_fd(view->sconn,1),purpose,retry);
   retry= 2;
   if(ret<0)
     goto ex;
   if(ret==0)
 break;
   if(old_view==view || old_view->sconn!=view->sconn)
 continue;
   if(strcmp(old_view->copy_target,copy_target)!=0)
 continue;
   /* eventually set copy_limit at old view and destroy new one */
   ret= Asview_set_copy_par(old_view,copy_target,copy_limit,keep_time,0);
   if(ret<=0)
     goto ex;
   if(encapsulated)
     old_view->encapsulated= encapsulated;
   Asview_destroy(&view,1);
   agent->keep_views= 1;
   ret= 2;
   goto ex;
 }

 ret= Asview_set_copy_par(view,copy_target,copy_limit,keep_time,0);
 if(ret<=0)
   goto ex;
 ret= Asview_add_subscr(view,purpose,"address",0);
 if(ret<=0)
   goto ex;
 if(Sregex_string(&actual_purpose,purpose,0)<=0)
   {ret= -1; goto ex;}
 if(!broadcast) {
   if(Sregex_string(&actual_purpose,"_copy",1)<=0)
     {ret= -1; goto ex;}
   ret= Asview_add_subscr(view,actual_purpose,"address",0);
   if(ret<=0)
     goto ex;
 }
 ret= Asview_send_start(view,0);
 if(ret<=0) {
   Asagent_stderr(agent,
                   "--- cannot send 'init' message for -show_copy:",0);
   Asagent_stderr(agent,in_cmd,1);
   ret= 0;
   goto ex;
 }

 agent->keep_views= 1;
 ret= 1;
ex:;
 Sregex_string(&connection,NULL,0);
 Sregex_string(&purpose,NULL,0);
 Sregex_string(&actual_purpose,NULL,0);
 Sregex_string(&copy_target,NULL,0);
 Sregex_string(&options,NULL,0);
 return(ret);
}


int Asagent_cmd_add_view(agent,in_cmd,flag)
struct AsagenT *agent;
char *in_cmd;
int flag;
{
 struct AsvieW *view= NULL;
 struct SconN *sconn= NULL;
 char connection[SfileadrL],type[Asview_id_strL];
 char representation[Asview_id_strL],id[Asview_id_strL];
 char *spt,*rpt;
 int ret,fd,new_view= 0,sconn_fd,option_present= 0,encapsulated= 0,efd;
 char cmd[2*SfileadrL];

 strcpy(cmd,in_cmd);

 ret= Asagent_get_permission(agent,"client","add_view",0);
 if(ret<=0)
   goto ex;

 Asagent_del_broken_views(agent,0);

 /* parse:  connection:type:representation  */
 spt= cmd;
 rpt= strchr(spt,':');
 if(rpt==NULL){
malformed:;
   Asagent_stderr(agent,"--- malformed options to -add_view : ",0);
   Asagent_stderr(agent,in_cmd,1);
   ret= 0;
   goto ex;
 }
 if(rpt-spt>=sizeof(connection))
   goto malformed;
 *rpt= 0;
 strcpy(connection,spt);
 spt= rpt+1;
 rpt= strchr(spt,':');
 if(rpt==NULL)
    goto malformed;
 if(rpt-spt>=sizeof(type))
   goto malformed;
 *rpt= 0;
 strcpy(type,spt);
 spt= rpt+1;
 rpt= strchr(spt,':');
 if(rpt==NULL)
   rpt= spt+strlen(spt);
 else
   option_present= 1;
 if(rpt-spt>=sizeof(representation))
   goto malformed;
 *rpt= 0;
 strcpy(representation,spt);
 if(option_present) {
   if(strcmp(rpt+1,"encapsulated")==0)
     encapsulated= 1;
   else if(strcmp(rpt+1,"open")==0)
     encapsulated= -1;
 }
 if(connection[0]==0) {
   goto malformed;
 } else if(strcmp(connection,"-")==0){
   fd= fileno(stdout);
   efd= Asagent_get_event_connection(agent,0);
   if(efd==-2)
     {ret= 2; goto ex;}                                      /* orphan event */
   if(efd!=-1)
     fd= efd;
   ret= Asagent_find_view(agent,&view,"pipe","","",fd,"",1);
   if(ret<0)
     goto ex;
 } else {
   ret= Asagent_find_view(agent,&view,"pipe","",connection,-1,"",0);
   if(ret<0)
     goto ex;
   if(ret>0)
     goto subscribe;
   fd= Asagent_open_outfile(agent,connection,"-add_view",0);
   if(fd==-1)
     { ret= 0; goto ex; }
 }

 if(view==NULL) {
   ret= Asagent_make_view(agent,&view,"pipe",0,connection,fd,0);
   if(ret<=0)
     goto ex;
   new_view= 1;
 }

subscribe:;
 if(encapsulated) 
   view->encapsulated= (encapsulated>0);
 ret= Asview_add_subscr(view,type,representation,0);
 if(ret<=0)
   goto ex;
 if(new_view){
   ret= Asview_send_start(view,0);
   if(ret<=0) {
     Asagent_stderr(agent,
                     "--- cannot send 'init' message for -add_view : ",0);
     Asagent_stderr(agent,in_cmd,1);
     ret= 0;
     goto ex;
   }
 }

 agent->keep_views= 1;
 ret= 1;
ex:;
 return(ret);
}


int Asagent_cmd_repair_icv(agent,in_cmd,flag)
struct AsagenT *agent;
char *in_cmd;
int flag;
{
 int ret;

 ret= Asagent_get_permission(agent,"modify","repair_icv",0);
 if(ret<=0)
   goto ex;

 if(strcmp(in_cmd,"on")==0){
   agent->repair_icv= 1;
   agent->repair_icv_idx= -1;
 } else {
   agent->repair_icv= 0;
 }
 ret= 1;
ex:
 return(ret);
}


int Asagent_cmd_security(agent,in_cmd,flag)
struct AsagenT *agent;
char *in_cmd;
int flag;
{
 int ret= 0,fd;
 struct SconN *sconn= NULL;
 struct SaccesS *access;
 char *stype= NULL,*type= NULL,*svalue,*cpt,*option= NULL,*value= NULL;
 char *ctrlvalue;

 ret= Asagent_get_permission(agent,"security","security",0);
 if(ret<=0)
   goto ex;

 /* type:option:value */
 cpt= in_cmd;
 ret= Sregex_cut_neck(cpt,':',&type,&cpt,0);
 if(ret<0)
   goto ex;
 if(ret==2 || strlen(cpt)==0) {
malformed:;
   Asagent_stderr(agent,"--- malformed options to -security : ",0);
   Asagent_stderr(agent,in_cmd,1);
   ret= 0; goto ex;
 }
 ret= Sregex_cut_neck(cpt,':',&option,&cpt,0);
 if(ret<0)
   goto ex;
 if(ret==2 || strlen(cpt)==0) 
   goto malformed;
 if(Sregex_string(&value,cpt,0)<=0)
   {ret= -1; goto ex;}

 /* test wether security control is allowed for this connection */
 sconn= NULL;
 fd= Asagent_get_event_connection(agent,0);
 if(fd>=0) {
   ret= Asqueue_find_sconn(agent->queue,&sconn,NULL,fd,0);
   if(ret<0) 
     goto ex;
 } else if (fd==-2) {                                        /* orphan event */
   goto denied;
 }
 if(sconn!=NULL) {
   ret= Sconn_get_typestring(sconn,&stype,1|2);
   if(ret<=0)
     goto ex;
   access= sconn->access;
 } else {
   Sregex_string(&stype,"internal",0);
   access= agent->access;
 }
 ret= Saccess_find_value(access,"connection",stype,"controller",&ctrlvalue,0);
 if(ret<0)
   goto ex;
 if(ctrlvalue==NULL)
   ctrlvalue= "off";
 if(strcmp(ctrlvalue,"on")!=0) {
denied:;
   Asagent_stderr(agent,"Connection type  ",0);
   Asagent_stderr(agent,stype,0);
   Asagent_stderr(agent,"  not enabled for command -security",1);
   ret= 0;
   goto ex;
 }

 /* >>> look for possible ad-hoc commands (value="current" or "#"+fd ) */

 if(strcmp(option,"user")==0 && strcmp(value,"internal_owner")==0) { 
   Asagent_stderr(agent,"User id  ",0);
   Asagent_stderr(agent,value,0);
   Asagent_stderr(agent,"  is reserved and may not be set by -security.",1);
   ret= 0;
   goto ex;
 }

 ret= Saccess_append(access,"connection",type,option,value,0);
 if(ret<=0)
   goto ex;

 ret= 1;
ex:;
 Sregex_string(&type,NULL,0);
 Sregex_string(&option,NULL,0);
 Sregex_string(&value,NULL,0);
 Sregex_string(&stype,NULL,0);
 return(ret);
}


int Asagent_cmd_synthetic(agent,in_cmd,flag)
struct AsagenT *agent;
char *in_cmd;
int flag;
/*
 bit1= do not complain loudely about unknown command
*/
{
 int ret,type,linemode,connection= -1;
 char *buf,*cpt,*username= NULL,*cmd= NULL;
 static char newline[2]={"\n"};
 
 ret= Asagent_get_permission(agent,"client","synthetic",0);
 if(ret<=0)
   goto ex;

 /* connection:type:text */
 cpt= in_cmd;
 ret= Sregex_cut_neck_int(cpt,':',&connection,&cpt,0);
 if(ret<0)
   goto ex;
 if(ret==2 || strlen(cpt)==0) {
malformed:;
   Asagent_stderr(agent,"--- malformed options to -synthetic : ",0);
   Asagent_stderr(agent,in_cmd,1);
   ret= 0; goto ex;
 }
 ret= Sregex_cut_neck_int(cpt,':',&type,&cpt,0);
 if(ret<0)
   goto ex;
 if(ret==2) 
   goto malformed;

 if(connection<0)
   connection= Asagent_get_event_connection(agent,0);
 else {
   /* >>> check wether this connection is known */;
   /* >>> if unknown : */
     connection= Asagent_get_event_connection(agent,0);
 }
 if(cpt[0]==0)
   buf= newline;
 else
   buf= cpt;
 if(type==0 || type==1)
   linemode= 0;
 else if(type==2)
   linemode= 1;
 else if(type==3) {
   Asagent_stdout(agent,cpt,1);
   ret= 1; goto ex;
 } else if(type==4) {
   Asagent_stderr(agent,cpt,1);
   ret= 1; goto ex;
 } else {
   Asagent_stderr(agent,"--- illegal input type option to -synthetic : ",0);
   Asagent_stderr(agent,in_cmd,1);
   ret= 0; goto ex;
 } 
 ret= Asagent_get_current_user(agent,&username,0);
 if(ret<=0)
   goto ex;
 ret= Asqueue_synthetic(agent->queue,buf,connection,username,linemode|4);
 if(ret<=0)
   goto ex;
 ret= Asqueue_advance(agent->queue,&(agent->event),0);
 if(ret<=0)
   goto ex;
 ret= Asevent_get_cmd(agent->event,&cmd,0);
 if(ret<=0)
   goto ex;
 if(strncmp(cmd,"-synthetic:",11)==0)
   if(strcmp(cmd+11,in_cmd)==0) {
     Asagent_stderr(agent,"Endless recursion caught with  -synthetic",1);
     agent->keep_views= 1;
     ret= 0; goto ex;
   }
 ret= Asagent_app_interpreter(agent,(flag&2));
 if(ret==4)
   ret= 0;
ex:
 Sregex_string(&cmd,NULL,0);
 Sregex_string(&username,NULL,0);
 return(ret);
}


int Asagent_cmd_refresh(agent,flag)
struct AsagenT *agent;
int flag;
{
 int ret,idx,count;
 char *adr;

 ret= Asagent_get_permission(agent,"info","refresh",0);
 if(ret<=0)
   goto ex;
 Asagent_stdout(agent,"",1);
 Asagent_stdout_bar(agent,0);
 ret= Asagent_determine_current(agent,&adr,&idx,&count,0);
 if(ret<=0)
   goto ex;
 else if(ret==2) 
   goto ex; /* no files in list */
 Asagent_print_fileinfo(agent,adr,0);
 ret= Asagent_show_doubles(agent,adr,1);
 if(ret<=0)
   goto ex;
 ret= Asagent_show_current(agent,adr,idx,0);
 if(ret<=0)
   goto ex;
 agent->no_keep_views_when_idle= 0;
 agent->keep_views= 1;
 ret= 1;
ex:
 return(ret);
}


int Asagent_cmd_tcp_client(agent,in_cmd,flag)
struct AsagenT *agent;
char *in_cmd;
int flag;
/*
 return values: 
  <=0 = error
  1 = all went normal
  3 = end agent service
*/
{
 int ret,portnumber;
 char *servername= NULL,*cpt,*file_representation= NULL;
 char *encapsulation= NULL,cmdline[81];

 ret= Asagent_get_permission(agent,"service","tcp_client",0);
 if(ret<=0)
   goto ex;

 /* servername:port:file_representation:encapsulation */
 cpt= in_cmd;
 ret= Sregex_cut_neck(cpt,':',&servername,&cpt,0);
 if(ret<0)
   goto ex;
 if(ret==2 || strlen(cpt)==0) {
malformed:;
   Asagent_stderr(agent,"--- malformed options to -tcp_client : ",0);
   Asagent_stderr(agent,in_cmd,1);
   ret= 0; goto ex;
 }
 ret= Sregex_cut_neck_int(cpt,':',&portnumber,&cpt,0);
 if(ret<=0)
   goto ex;
 ret= Sregex_cut_neck(cpt,':',&file_representation,&cpt,0);
 if(ret<=0)
   goto ex;
 if(Sregex_string(&encapsulation,cpt,0)<=0)
   {ret= -1; goto ex;}

 ret= Asagent_tcp_client(agent,servername,portnumber,
                          file_representation,encapsulation,0);
ex:;
 Sregex_string(&servername,NULL,0);
 Sregex_string(&file_representation,NULL,0);
 Sregex_string(&encapsulation,NULL,0);
 return(ret);
}


int Asagent_cmd_make_userkey(agent,in_cmd,flag)
struct AsagenT *agent;
char *in_cmd;
int flag;
{
 int ret= 0;
 struct StunneL *tunnel= NULL;
 char *cpt,*keydir,*typestring= NULL,*username= NULL;

 ret= Asagent_get_permission(agent,"security","make_userkey",0);
 if(ret<=0)
   goto ex;

 /* type:user */
 cpt= in_cmd;
 ret= Sregex_cut_neck(cpt,':',&typestring,&cpt,0);
 if(ret<0)
   goto ex;
 if(ret==2 || strlen(cpt)==0) {
malformed:;
   Asagent_stderr(agent,"--- malformed options to -make_userkey : ",0);
   Asagent_stderr(agent,in_cmd,1);
   ret= 0; goto ex;
 }
 if(Sregex_string(&username,cpt,0)<=0)
   {ret= -1; goto ex;}
 ret= Saccess_find_value(agent->access,"connection",typestring,"keydirectory",
                         &keydir,0);
 if(ret<=0) {
   Asagent_stderr(agent,
                   "--- unable to determine key directory. use -security:",0);
   Asagent_stderr(agent,typestring,0);
   Asagent_stderr(agent,":keydirectory:...",1);
   ret= 0; goto ex;
 }
 ret= Stunnel_new(&tunnel,username,-1,keydir,1);
 if(ret<=0)
   goto ex;
 ret= Stunnel_make_userkey(tunnel,0);
 if(ret<=0) {
   Asagent_stderr(agent,"--- creation of userkey file failed",1);
   Asagent_stderr(agent,"--- ",0);
   Asagent_stderr(agent,tunnel->errmsg,1);
   goto ex;
 }
 Asagent_stdout(agent,"userkey file created : ",0);
 Asagent_stdout(agent,keydir,0);
 Asagent_stdout(agent,"/",0);
 Asagent_stdout(agent,username,0);  
 Asagent_stdout(agent,".tnl",1);
 ret= 1;
ex:;
 Stunnel_destroy(&tunnel,0);
 Sregex_string(&typestring,NULL,0);
 Sregex_string(&username,NULL,0);
 return(ret);
}


int Asagent_cmd_internal(agent,in_cmd,flag)
struct AsagenT *agent;
char *in_cmd;
int flag;
{
 int ret;
 char *cpt,*setting= NULL,*purpose= NULL;

 ret= Asagent_get_permission(agent,"service","internal",0);
 if(ret<=0)
   goto ex;

 /* parse: purpose:setting */
 cpt= in_cmd;
 ret= Sregex_cut_neck(cpt,':',&purpose,&cpt,0);
 if(ret<0)
   goto ex;
 if(ret==2 || strlen(cpt)==0) {
malformed:;
   Asagent_stderr(agent,"--- malformed options to -internal : ",0);
   Asagent_stderr(agent,in_cmd,1);
   ret= 0; goto ex;
 }
 ret= Sregex_string(&setting,cpt,0);
 if(ret<=0)
   goto ex;
 if(strcmp(setting,"on")!=0 && strcmp(setting,"off")!=0)
   goto malformed;

 if(strcmp(purpose,"current_file")==0 || strcmp(purpose,"all")==0) {
   if(strcmp(setting,"off")==0) {
     ret= Asagent_hide(agent,1|4);
     if(ret<=0)
       goto ex;
     agent->disable_internal|= 1;
   } else
     agent->disable_internal&= ~1;
 }
 if(strcmp(purpose,"double_files")==0 || strcmp(purpose,"all")==0) {
   if(strcmp(setting,"off")==0) {
     ret= Asagent_hide(agent,2|4);
     if(ret<=0)
       goto ex;
     agent->disable_internal|= 2;
   } else 
     agent->disable_internal&= ~2;
 }
 if(strcmp(purpose,"stdout")==0 || strcmp(purpose,"all")==0) {
   if(strcmp(setting,"off")==0)
     agent->disable_internal|= 4;
   else
     agent->disable_internal&= ~4;
 }
 if(strcmp(purpose,"stderr")==0 || strcmp(purpose,"all")==0) {
   if(strcmp(setting,"off")==0)
     agent->disable_internal|= 8;
   else
     agent->disable_internal&= ~8;
 }
 if(strcmp(purpose,"termios")==0 || strcmp(purpose,"all")==0) {
   if(strcmp(setting,"off")==0) {
     agent->disable_internal|= (1<<16);
     Asqueue_set_internal(agent->queue,0,0);
   } else {
     agent->disable_internal&= ~(1<<16);
     Asqueue_set_internal(agent->queue,1,0);
   }
 }
 ret= 1;
ex:;
 Sregex_string(&purpose,NULL,0);
 Sregex_string(&setting,NULL,0);
 return(ret);
}


int Asagent_cmd_permission(agent,in_cmd,flag)
struct AsagenT *agent;
char *in_cmd;
int flag;
{
 int ret= 0;
 struct SconN *sconn= NULL;
 char *username= NULL,*svalue,*cpt,*option= NULL,*value= NULL;
 char *ctrlvalue;

 ret= Asagent_get_permission(agent,"security","permission",0);
 if(ret<=0)
   goto ex;

 /* username:class[-action]:value */
 cpt= in_cmd;
 ret= Sregex_cut_neck(cpt,':',&username,&cpt,0);
 if(ret<0)
   goto ex;
 if(ret==2 || strlen(cpt)==0) {
malformed:;
   Asagent_stderr(agent,"--- malformed options to -security : ",0);
   Asagent_stderr(agent,in_cmd,1);
   ret= 0; goto ex;
 }
 ret= Sregex_cut_neck(cpt,':',&option,&cpt,0);
 if(ret<=0)
   goto ex;
 if(ret<0)
   goto ex;
 if(ret==2 || strlen(cpt)==0) 
   goto malformed;
 if(Sregex_string(&value,cpt,0)<=0)
   {ret= -1; goto ex;}
 
 ret= Saccess_append(agent->access,"permission",username,option,value,0);
 if(ret<=0)
   goto ex;

 ret= 1;
ex:;
 agent->keep_views= 1;
 Sregex_string(&username,NULL,0);
 Sregex_string(&option,NULL,0);
 Sregex_string(&value,NULL,0);
 return(ret);
}


int Asagent_cmd_encapsulate_views(agent,in_cmd,flag)
struct AsagenT *agent;
char *in_cmd;
int flag;
{
 int ret= 0;

 ret= Asagent_get_permission(agent,"service","encapsulate_views",0);
 if(ret<=0)
   return(ret);
 if(strcmp(in_cmd,"off")==0 || strcmp(in_cmd,"clear")==0)
   agent->encapsulate_views= 0;
 else
   agent->encapsulate_views= 1;
 agent->keep_views= 1;
 return(1);
}


int Asagent_cmd_bundle(agent,in_cmd,flag)
struct AsagenT *agent;
char *in_cmd;
int flag;
{
 int ret;

 ret= Asagent_get_permission(agent,"client","bundle",0);
 if(ret<=0)
   return(ret);

 /* this command should be handled inside AsinconN */
 if(strcmp(in_cmd,"start")!=0 && strcmp(in_cmd,"end")!=0) {
   Asagent_stderr(agent,"Malformed option to command -bundle : '",0);
   Asagent_stderr(agent,in_cmd,0);
   Asagent_stderr(agent,"'",1);
   return(0);
 }
 agent->keep_views= 1;
 return(1);
}


int Asagent_cmd_double_check(agent,in_cmd,flag)
struct AsagenT *agent;
char *in_cmd;
int flag;
{
 int ret;

 ret= Asagent_get_permission(agent,"service","double_check",0);
 if(ret<=0)
   return(ret);

 if(strcmp(in_cmd,"off")==0)
   agent->look_for_doubles= 0;
 else if(strcmp(in_cmd,"auto")==0)
   agent->look_for_doubles= 1;
 else if(strcmp(in_cmd,"on")==0)
   agent->look_for_doubles= 2;
 else {
   Asagent_stderr(agent,"Malformed option to command -double_check : '",0);
   Asagent_stderr(agent,in_cmd,0);
   Asagent_stderr(agent,"' (use: on|auto|off)",1);
   return(0);
 }
 return(1);
}


int Asagent_cmd_preserve_orphan_events(agent,in_cmd,flag)
struct AsagenT *agent;
char *in_cmd;
int flag;
{
 int ret;

 ret= Asagent_get_permission(agent,"service","preserve_orphan_events",0);
 if(ret<=0)
   return(ret);

 if(strcmp(in_cmd,"off")==0)
   agent->preserve_orphan_events= 0;
 else if(strcmp(in_cmd,"on")==0)
   agent->preserve_orphan_events= 1;
 else {
   Asagent_stderr(agent,
                  "Malformed option to command -preserve_orphan_events : '",0);
   Asagent_stderr(agent,in_cmd,0);
   Asagent_stderr(agent,"' (use: on|off)",1);
   return(0);
 }
 return(1);
}


int Asagent_cmd_mark(agent,in_cmd,flag)
struct AsagenT *agent;
char *in_cmd;
int flag;
/*
 bit1= do not complain loudely about unknown command
 bit8= request rather than mark

return:
 <=0 = error
   1 = ok
   2 = execute command remotely
   3 = end agent/client service
   4 = unknown command
*/
{
 int ret,hret=0,encapsulate_views,request_mode;
 char *mark_id= NULL,*cmd= NULL,*cpt,*username= NULL,*buffer= NULL;
 struct LstrinG *lstring;

 if(flag&256)
   ret= Asagent_get_permission(agent,"client","request",0);
 else 
   ret= Asagent_get_permission(agent,"client","mark",0);
 if(ret<=0)
   goto ex;

 /* id:command */
 cpt= in_cmd;
 ret= Sregex_cut_neck(cpt,':',&mark_id,&cpt,0);
 if(ret<0)
   goto ex;
 ret= Asagent_eval(agent,mark_id,&mark_id,0);
 if(ret<=0)
   goto ex;
 if(strlen(mark_id)>SfileadrL)
   mark_id[SfileadrL]= 0;

 if((agent->service_mode==1) && !Asagent_is_local_cmd(agent,cpt,1)) {

   return(2);

   /* >>> find view allegible for this mark notification */
   /* >>> prepend view id to mark id */
   /* >>> recombine -mark, id and command */
   /* >>> send to server */
 } else {
   ret= Asagent_notify_mark(agent,mark_id,NULL,flag&256);
   if(ret<=0)
     goto ex;
   if(!(flag&256)) {
     ret= Lstring_new(&lstring,mark_id,agent->markstack,0);
     if(ret<=0)
       goto ex; 
   }
   ret= Asagent_execute_subcmd(agent,cpt,flag&(2|256));
   if(ret<0)
     goto ex;
   if(flag&256)
     hret= Asagent_notify_mark(agent,mark_id,NULL,1|(flag&256));
  
   if(hret<0)
     {ret= hret; goto ex;}
 }
ex:;
 Sregex_string(&mark_id,NULL,0);
 Sregex_string(&cmd,NULL,0);
 Sregex_string(&username,NULL,0);
 Sregex_string(&buffer,NULL,0);
 return(ret);
}


int Asagent_cmd_user(agent,in_cmd,flag)
struct AsagenT *agent;
char *in_cmd;
int flag;
/*
 bit1= do not complain loudely about unknown command

return:
 <=0 = error
   1 = ok
   2 = execute command remotely
   3 = end agent/client service
   4 = unknown command
*/
{
 int ret,hret,encapsulate_views,request_mode;
 char *username= NULL,*cpt,*auth_username= NULL;
 struct LstrinG *lstring= NULL;

 /* id:command */
 cpt= in_cmd;
 ret= Sregex_cut_neck(cpt,':',&username,&cpt,0);
 if(ret<0)
   goto ex;
 ret= Asagent_get_permission(agent,"user",username,0);
 if(ret<=0)
   goto ex;

 if((agent->service_mode==1) && !Asagent_is_local_cmd(agent,cpt,1)) {
   ret= 2; 
 } else {
   if(Lstring_new(&lstring,username,agent->current_users,0)<=0)
     {ret= -1; goto ex;}
   ret= Asagent_execute_subcmd(agent,cpt,flag&(2));
   if(ret<=0)
     goto ex;
 }
ex:;
 Lstring_destroy(&lstring,0);
 Sregex_string(&username,NULL,0);
 Sregex_string(&auth_username,NULL,0);
 return(ret);
}


int Asagent_cmd_viewer_cmd(agent,in_cmd,flag)
struct AsagenT *agent;
char *in_cmd;
int flag;
{
 int ret;
 struct AsvieW *view;

 ret= Asagent_get_permission(agent,"security","viewer_cmd",0);
 if(ret<=0)
   return(ret);
 Asviewproto_destroy(&(agent->view_prototype),0);
 ret= Asviewproto_new(&(agent->view_prototype),in_cmd,0);
 if(ret<=0)
   return(ret);
 for(view= agent->views;view!=NULL;view= view->next) 
   Asview_set_proto(view,agent->view_prototype,0);
 return(1);
}


int Asagent_cmd_for(agent,in_cmd,flag)
struct AsagenT *agent;
char *in_cmd;
int flag;
/*
 bit1= do not complain loudely about unknown command

return: see Asagent_interpreter()
*/
{
 Asagent_stderr(agent,"No application linked. No usable index range.",1);
 return(0);
}


int Asagent_cmd_where(agent,in_cmd,flag)
struct AsagenT *agent;
char *in_cmd;
int flag;
/*
 bit1= do not complain loudely about unknown command

return: see Asagent_interpreter()
*/
{
 Asagent_stderr(agent,"No application linked. No usable index range.",1);
 return(0);
}


int Asagent_interpreter(agent,flag)
struct AsagenT *agent;
int flag;
/*
 bit0= quiet : do not report command
 bit1= do not complain loudely about unknown command
 bit2= client mode (call Asagent_client_interpreter() and return)
 bit3= forced local mode
*/
/*
 return values: 
  <=0 = error
  1 = all went normal
  2 = redo user interaction
  3 = end agent service
  4 = unknown command
*/
{
 char *cmd= NULL,line[SfileadrL],*adr,*username= NULL,*subcmd= NULL;
 int ret,idx,no_files= 0,yes= 0,count,i;

 if(((flag&4) || agent->service_mode==1) && !(flag&8)) {
   ret= Asagent_client_interpreter(agent,0);
   return(ret);
 }

 agent->input_fd= Asagent_get_event_connection(agent,0);
 agent->recursion_level++;
 if(agent->recursion_level>agent->recursion_max){
   Asagent_stderr(agent,
             "Command recursion too deep, probably endless -readfrom loop.",1);
   ret= 0;
   goto ex;
 }

 ret= Asagent_determine_current(agent,&adr,&idx,&count,0);
 if(ret<=0)
   goto ex;
 else if(ret==2)
   no_files= 1;
again:;
 ret= Asevent_get_cmd(agent->event,&cmd,0);
 if(ret<=0)
   goto ex;
 if(strncmp(cmd,"--imvagent",10)==0) {
   /* remove own module prefix if there */
   for(i=10;cmd[i]!=0;i++)
     cmd[i-10]= cmd[i];
   cmd[i]= 0;
 }

 ret= 0;
 if(!(flag&1)) {
   sprintf(line,"%ld> ",Asagent_get_event_connection(agent,0));
   Asagent_stdout(agent,line,0);
   Asagent_stdout(agent,cmd,1);
 }
 if(cmd[0]==0||cmd[0]=='#'||cmd[0]=='!') {
   ;
 } else if(cmd[0]==':' && cmd[1]!=0) {
   if(Sregex_string(&subcmd,"-1:1",0)<=0)
     {ret= -1; goto ex;}
   if(Sregex_string(&subcmd,cmd,1)<=0)
     {ret= -1; goto ex;}
   subcmd[6]= 0;
   ret= Asagent_cmd_synthetic(agent,subcmd,0);
   if(ret!=1)
     goto ex;
 } else if(strncmp(cmd,"-help",5)==0){
   ret= Asagent_cmd_help(agent,strcmp(cmd,"-help_short")==0);
   if(ret<=0)
     goto ex;
 } else if(strncmp(cmd,"-add_view",9)==0 && cmd[9]!=0) {
   ret= Asagent_cmd_add_view(agent,cmd+10,0);
   if(ret<=0)
     goto ex;
 } else if(strcmp(cmd,"-arguments_to_queue")==0) {
   Asagent_set_arguments_to_queue(agent,1,0);
 } else if(strcmp(cmd,"-ask_end")==0) {
   ret= Asagent_get_permission(agent,"end","ask_end",0);
   if(ret<=0)
     goto ex;
   Asagent_stdout(agent,"Do you really want to end the program ?",1);
   ret= Asagent_fetch_yesno(agent,
                             "Do you really want to end the program ?",&yes,1);
   if(ret<=0)
     goto ex;
   if(yes)
     ret= 3;
   else
     ret= 1;
   goto ex;
 } else if(strncmp(cmd,"-bundle",7)==0 && cmd[7]!=0) {
   ret= Asagent_cmd_bundle(agent,cmd+8,0);
   if(ret<=0)
     goto ex;
 } else if(strncmp(cmd,"-double_check",13)==0 && cmd[13]!=0) {
   ret= Asagent_cmd_double_check(agent,cmd+14,0);
   if(ret<=0)
     goto ex;
 } else if(strncmp(cmd,"-encapsulate_views",18)==0 && cmd[18]!=0){
   ret= Asagent_cmd_encapsulate_views(agent,cmd+19,0);
   if(ret<=0)
     goto ex;
 } else if(strcmp(cmd,"-end")==0) {
   ret= Asagent_get_permission(agent,"end","end",2);
   if(ret<=0)
     goto ex;
   ret= 3;
   goto ex;
 } else if(strcmp(cmd,"-end_client")==0) {
   ; /* only interesting in client mode */
 } else if(strcmp(cmd,"-end_server")==0) {
   ; /* only interesting in client mode */
 } else if(strncmp(cmd,"-end_on",7)==0 && cmd[7]!=0){
   ret= Asagent_cmd_end_on(agent,cmd+8,0);
   if(ret<=0)
     goto ex;
 } else if(strncmp(cmd,"-for",4)==0 && cmd[4]!=0){
   Asagent_cmd_for(agent,cmd+5,0);
   if(ret<=0)
     goto ex;
 } else if(strncmp(cmd,"-input_ready_fd",15)==0 && cmd[15]!=0) {

   /* >>> determine role of reported file descriptor */
     /* >>> client_sconn , (nntpconn) */

   ; /* client_sconn: only interesting in client mode */
 } else if(strncmp(cmd,"-internal",9)==0 && cmd[9]!=0) {
   ret= Asagent_cmd_internal(agent,cmd+10,0);
   if(ret<=0)
     goto ex;
 } else if(strncmp(cmd,"-keyset",7)==0 && cmd[7]!=0) {
   ret= Asagent_get_permission(agent,"service","keyset",0);
   if(ret<=0)
     goto ex;
   ret= Asprog_define(agent->queue->input->prog,cmd+8,0);
   if(ret<=0)
     goto ex;
   ret= Asagent_set_trashdir(agent,agent->queue->input->prog->trashdir,0);
   if(ret<=0)
     goto ex;
   ret= Asagent_set_maindir(agent,agent->queue->input->prog->maindir,0);
   if(ret<=0)
     goto ex;
   if(ret>1){
     if(ret==2) 
       Asagent_stderr(agent,"statement after -keyset not recognized :",1);
     else if(ret==3) 
       Asagent_stderr(agent,"statement after -keyset incomplete :",1);
     else if(ret==4)
       Asagent_stderr(agent,"statement after -keyset has bad parameters :",1);
     Asagent_stderr(agent,cmd+8,1);
     goto ex;
   }
 } else if(strncmp(cmd,"-local_cmd",10)==0 && cmd[10]!=0) {
   ret= Asagent_get_permission(agent,"local_cmd","local_cmd",0);
   if(ret<=0)
     goto ex;
   ret= Asagent_execute_subcmd(agent,cmd+11,(flag&2)|8);
   goto ex;
 } else if(strncmp(cmd,"-make_userkey",13)==0 && cmd[13]!=0) {
   ret= Asagent_cmd_make_userkey(agent,cmd+14,0);
   if(ret<=0)
     goto ex;
 } else if(strncmp(cmd,"-mark",5)==0 && cmd[5]!=0) {
   ret= Asagent_cmd_mark(agent,cmd+6,flag&2);
   if(ret<=0)
     goto ex;
 } else if(strcmp(cmd,"-noop")==0) {
   static int noop_counter= 0;
   ret= Asagent_get_permission(agent,"client","noop",0);
   if(ret<=0)
     goto ex;
   noop_counter++;
   if((noop_counter%10)==0)
     fprintf(stderr,"\rnoop : %ld  ",noop_counter);
 } else if(strncmp(cmd,"-permission",11)==0 && cmd[11]!=0) {
   ret= Asagent_cmd_permission(agent,cmd+12,0);
   if(ret<=0)
     goto ex;
 } else if(strncmp(cmd,"-pipe_service",13)==0 && cmd[13]!=0) {
   ret= Asagent_cmd_pipe_service(agent,cmd+14,0);
   if(ret<=0)
     goto ex;
 } else if(strncmp(cmd,"-preserve_orphan_events",23)==0 && cmd[23]!=0) {
   ret= Asagent_cmd_preserve_orphan_events(agent,cmd+24,0);
   if(ret<=0)
     goto ex;
 } else if(strcmp(cmd,"-queue_canceled")==0) {
   ; /* only interesting in client mode */
 } else if(strncmp(cmd,"-readfrom",9)==0 && cmd[9]!=0) {
   ret= Asagent_get_current_user(agent,&username,1);
   if(ret<=0)
     goto ex;
   ret= Asagent_cmd_readfrom(agent,cmd+10,
                              Asagent_get_event_connection(agent,0),
                              username,0);
   if(ret<=0)
     goto ex;
   if(ret==3)
     goto ex;
 } else if(strcmp(cmd,"-refresh")==0 ) {
   ret= Asagent_cmd_refresh(agent,0);
   if(ret<=0)
     goto ex;
 } else if(strncmp(cmd,"-repair_icv",11)==0 && cmd[11]!=0) {
   ret= Asagent_cmd_repair_icv(agent,cmd+12,0);
   if(ret<=0)
     goto ex;
 } else if(strncmp(cmd,"-request",8)==0 && cmd[8]!=0) {
   ret= Asagent_cmd_mark(agent,cmd+9,256|(flag&2));
   if(ret<=0)
     goto ex;
 } else if(strncmp(cmd,"-shell",6)==0 && cmd[6]!=0) {
   ret= Asagent_cmd_shell(agent,cmd+7,0);
   if(ret<=0)
     goto ex;
 } else if(strncmp(cmd,"-show_copy",10)==0 && cmd[10]!=0) {
   ret= Asagent_cmd_show_copy(agent,cmd+11,0);
   if(ret<=0)
     goto ex;
 } else if(strncmp(cmd,"-security",9)==0 && cmd[9]!=0) {
   ret= Asagent_cmd_security(agent,cmd+10,0);
   if(ret<=0)
     goto ex;
 } else if(strncmp(cmd,"-synthetic",10)==0 && cmd[10]!=0) {
   ret= Asagent_cmd_synthetic(agent,cmd+11,0);
   if(ret!=1)
     goto ex;
 } else if(strncmp(cmd,"-tcp_client",11)==0 && cmd[11]!=0) {
   ret= Asagent_cmd_tcp_client(agent,cmd+12,0);
   if(ret<=0)
     goto ex;
 } else if(strncmp(cmd,"-tcp_service",12)==0 && cmd[12]!=0) {
   ret= Asagent_cmd_tcp_service(agent,cmd+13,0);
   if(ret<=0)
     goto ex;
 } else if(strncmp(cmd,"-user",5)==0 && cmd[5]!=0) {
   ret= Asagent_cmd_user(agent,cmd+6,0);
   if(ret<=0)
     goto ex;
 } else if(strncmp(cmd,"-viewer_cmd",11)==0 && cmd[11]!=0) {
   ret= Asagent_cmd_viewer_cmd(agent,cmd+12,0);
   if(ret<=0)
     goto ex;
 } else {
   if(!(flag&2)){
     sprintf(line,"--- command not recognized : '%s'",cmd);
     Asagent_stderr(agent,line,1);
   }
   ret= 4; goto ex;
 }
 if(ret==0) ret= 1;
ex:;
 Sregex_string(&subcmd,NULL,0);
 Sregex_string(&cmd,NULL,0);
 Sregex_string(&username,NULL,0);
 agent->recursion_level--;
 return(ret);
}


int Asagent_loop(agent,flag)
struct AsagenT *agent;
int flag;
/*
 flag:
  bit0= do not print file info
  bit15= return on idle
 return:
 <=0 : error
 1   : ok
 3   : end agent service
*/
{
 int ret,idx,count,no_files,not_shown,fstep,show_in_any_case= 0,prompted= 0,ok;
 int loop_count= 0,apcmem;
 struct AsvieW *current,*prev= NULL,*next= NULL;
 char *adrpt;

 if(agent==NULL)
   return(0);

 apcmem= agent->permission_check;
 agent->permission_check= 1;      /* just in case we got here during startup */
 show_in_any_case= 1;

 while(1){
   loop_count++;
   if(agent->smem_stderr>0)                /* in case we search memory leaks */
     if((loop_count%agent->smem_stderr)==0)
       Smem_stderr(0);
show_full_again:;
   no_files= 0;
   ret= Asagent_determine_current(agent,&adrpt,&idx,&count,0);
   if(ret<=0)
     goto ex;
   else if(ret==2) {
     no_files= 1;
   }
   if(no_files)
     show_in_any_case= 0;

   if(!(flag&1))
     if(show_in_any_case || !agent->keep_views) {
       Asagent_stdout(agent,"",1);
       Asagent_stdout_bar(agent,0);
       if(!no_files) 
         Asagent_print_fileinfo(agent,adrpt,0);
     }
show_again:;
   not_shown= 0;
   if(Asqueue_event_is_pending(agent->queue,0)) {
     if(show_in_any_case || !(agent->keep_views || no_files)) 
       agent->no_keep_views_when_idle= 1;
     agent->keep_views= 1;
   } else { 
     if(agent->no_keep_views_when_idle)
       agent->keep_views= 0;
     if((flag&(1<<15))||agent->loop_return_on_idle)
       {ret= 1; goto ex;}
   }
   if(show_in_any_case || !(agent->keep_views || no_files)) {
     ret= Asagent_show_doubles(agent,adrpt,1);
     if(ret<=0)
       goto ex;
     ret= Asagent_show_current(agent,adrpt,idx,0);
     if(ret<=0)
       goto ex;
     agent->no_keep_views_when_idle= 0;
   } else if(!agent->keep_views)
     not_shown= 1;
   show_in_any_case= 0;
   agent->keep_views= 0;
   if(!(prompted || Asqueue_event_is_pending(agent->queue,0))) {
     Asagent_establish_alarm(agent,0);                /* enable idle alarm */
     Asagent_notify_prompt(agent,0);
     prompted= 1;
   }
   /* notify end to all stacked marks */
   ret= Asagent_notify_mark(agent,NULL,NULL,2);
   if(ret<0)
     goto ex;
   while(1) {                                          /* waiting for input */
     Asview_try_outbuffers(agent->views,0);
     Asagent_consume_messages(agent,0);
     Asrm_process_all(agent->deferred_rm_jobs,0);
     ret= Asagent_check_icv(agent,0);
     if(ret<0)
       goto ex;
     if(ret==3) {
       show_in_any_case= 1;
       goto show_full_again;
     }
     Asevent_destroy(&(agent->event),0);
     Asagent_reset_input_source(agent,0);
     ret= Asqueue_advance(agent->queue,&(agent->event),0);
     if(ret<0)
       goto ex;
     if(ret>0)
   break;
     if(not_shown)
       goto show_again;
   }
   agent->input_fd= Asagent_get_event_connection(agent,0);
   if(prompted){
     Asagent_establish_alarm(agent,8);                /* disable idle alarm */
     Asagent_notify_prompt(agent,1);
     prompted= 0;
   }

   /* >>> ASNNTP check wether -interrupt_service_loop is required */;

   ret= Asagent_app_interpreter(agent,0);
   if(ret<0)
     goto ex;
   if(ret==3){
     if(!agent->silent_end)
       Asagent_stdout(agent,"=== end command received.",1);
     goto ex;
   }
   if(ret==0){
     Asagent_stderr(agent,"--- operation failed !",1);
   }
   if(!(agent->keep_views || not_shown)) {
     Asagent_hide(agent,3);                 /* hide "current" and "doubles" */
   }
   ret= Asagent_cursor_advance(agent,&fstep,0);
   if(ret<=0) {
     if(((agent->end_on_flag)&1) && fstep==1) {
       Asagent_stdout(agent,
          "=== end of file list reached. -end_on:list_end is set. Goodbye.",1);
       ret= 3;
       goto ex;
     } else 
       Asagent_stderr(agent,"--- already at end of file list ---",1);
   }
 }
 ret= 1;
ex:;
 Asview_try_outbuffers(agent->views,0);
 Asagent_consume_messages(agent,0);
 Asagent_hide(agent,3);                     /* hide "current" and "doubles" */
 agent->permission_check= apcmem;
 return(ret);
}


int Asagent_read_options(agent,argc,argv,ard,flag)
struct AsagenT *agent;
int argc;
char **argv;
int *ard;
int flag;
/*
 return:
 <=0 : error
   1 : ok
   3 : end agent service
*/
{
 int ret,return_3=0,apcmem;
 char cmd[SfileadrL*2];

 if(agent==NULL)
   return(0);
 apcmem= agent->permission_check;
 agent->permission_check= 0;
 for(;(*ard)<argc;(*ard)++){
   strcpy(cmd,argv[(*ard)]);
   Asevent_destroy(&(agent->event),0);
   ret= Asevent_new(&(agent->event),cmd,-1,"internal_owner",0);
   if(ret<=0)
     goto ex;
   if(agent->arguments_to_queue){
     ret= Asqueue_append(agent->queue,&(agent->event),0);
     if(ret<=0)
       goto ex;
     agent->event= NULL;
   } else {
     ret= Asagent_app_interpreter(agent,1);
     if(ret<=0||ret==3)
       goto ex;
     if(strcmp(argv[(*ard)],"-help")==0 && (*ard)==argc-1)
       return_3= 1;
   }
 }
 ret= 1;
 if(return_3)
   ret= 3;
ex:;
 agent->permission_check= apcmem;
 return(ret);
}

