
#ifndef Asinput_includeD
#define Asinput_includeD Yes

#ifdef Asinput_use_curseS
#undef Asinput_use_curseS
#endif

#define Asinput_curses_halfdelaY 1

#define Asinconn_linesizE 65336
#define Asinconn_default_bundle_sizE Asinconn_linesizE

#define Asinput_sconN


struct AsinconN {

 struct AsinpuT *input;
 struct AsagenT *agent;

 int type;     /*
                  bit0-3=  mode
                           0= internal character oriented input
                              single keystrokes with @ as escape to line input
                           1= character oriented input
                              single keystrokes with @ as escape to line input
                           2= line oriented input
                              lines ending with \n or 0
                           3= data to be sent to stdout
                           4= data to be sent to stderr
                           5= do not read but return -input_ready_fd:<fd>    
                 >>>ASNNTP 6= do not read but return -interrupt_service_loop    

                  bit8=  source of commands
                  bit9=  source of requested input
                  bit10= master socket (accept rather than read)
                  bit11= dummy socket (do not select)
                  bit12= not a socket but a regular filedescriptor
                  bit13= temporary file object, remove on close
                */

 int bundle_max_size;
 int bundle_overflow;
 char *bundle_endmark;
 char *bundle_buffer;

 struct SconN *sconn;
 int keep_pipe_alive_fd;

 struct AsinconN *prev,*next;
 
};


struct AsinpuT {

 struct AsqueuE *queue;
 struct AsagenT *agent;

 int type;            /* 
                         bit0=  internal char input is served independent of
                                connection list (usually it isn't in that list)
                       */

 int initialized;     /* ??? */

#ifndef Asinput_use_curseS
 struct termios *termios_orig;
#endif

 struct StcpserV *char_serv;    /* reception server for  type:bit1 */
 struct StcpserV *line_serv;    /* reception server for  type:bit2 */
 struct AsinconN *connections;
 struct AsinconN *conn_pt;     /* choosen connection */

 struct AsproG  *prog;  /* struct VerteilplaN ; struct VerteilanweisunG */

 char **reply;
 int reply_count;
 int reply_type;      /* 0= data , 1= control */
                      /* controls:
                            CANCEL (throw away the whole queue)  
                       */
 int from_connection;
 char *username;
};


#endif /* ! Asinput_includeD */

