

/*
 cc -g -c ../as/asrm.c
*/

#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>


#include "../s_tools/smem.h"

#include "../as/asrm.h"


/* -------------------------------- AsrM  ------------------------------ */


int Asrm_new(rm,deadline,adr,link,flag)
struct AsrM **rm;
double deadline;
char *adr;
struct AsrM *link;
int flag;
/*
 bit0= insert before link rather than after it
*/
{
 struct AsrM *r;
 
 *rm= r= TSOB_FELD(struct AsrM,1);
 if(r==NULL)
   return(-1);
 r->deadline= deadline;
 r->adr= NULL;
 r->prev= r->next= NULL;

 if(Sregex_string(&(r->adr),adr,0)<=0)
   goto failed;
 if(link==NULL) {
   ;
 } else if(flag&1) {
   r->next= link;
   r->prev= link->prev;
   if(link->prev!=NULL)
     link->prev->next= r;
   link->prev= r;
 } else {
   r->prev= link;
   r->next= link->next;
   if(link->next!=NULL)
     link->next->prev= r;
   link->next= r;
 }
 return(1);
failed:
 Asrm_destroy(r,NULL);
 return(-1);
}


int Asrm_destroy(rm,flag)
struct AsrM **rm;
{
 struct AsrM *s;

 s= *rm;
 if(s==NULL)
   return(0);
 if(s->prev!=NULL)
   s->prev->next= s->next;
 if(s->next!=NULL)
   s->next->prev= s->prev;
 Sregex_string(&(s->adr),NULL,0);
 Smem_freE((char *) s);
 *rm= NULL;
 return(1);
}


int Asrm_add_after(rm,deadline,adr,flag)
struct AsrM *rm;
double deadline;
char *adr;
int flag;
{
 struct AsrM *r;
 int ret;

 ret= Asrm_new(&r,deadline,adr,rm,0);
 return(ret);
}


int Asrm_process_all(rm,flag)
struct AsrM *rm;
int flag;
/*
 bit0= force expiration of deadline
*/
{
 struct AsrM *s,*next;
 double now,Sfile_microtime();

 if(rm==NULL)
   return(0);
 for(s= rm; s->prev!=NULL; s= s->prev);
 now= Sfile_microtime(0);
 for(;s!=NULL;s= next){
   next= s->next;
   if(s->deadline>now && !(flag&1))
 continue;
   if(s->adr!=NULL)
     if(s->adr[0]!=0)
       unlink(s->adr);
   Asrm_destroy(&s,0);
 }
 return(1);
}



