

#ifndef Imgdbs_includeD
#define Imgdbs_includeD

#include <mysql/mysql.h>

#define Imgdbs_dbtypE "mysql"


#include "../s_tools/sfile.h"


#define Imgdbs_reconnect_maxtrY 5


struct ImgdbS {

 struct ImgdB *imdb;

 char *hostname;
 char *username;
 char *password;
 char *dbname;

 MYSQL *db;
 int opened;

 int has_similar_udf;
 int has_color_avg;

 int fetch_mode;      /* How to fetch the result rows (preferrably)
                           0= all at once ( mysql_store_result() )
                           1= one by one ( mysql_use_result() )
                       */

 int sample_format;   /* How to represent sample data in the table
                           0= single binary string (116 bytes)
                           1= pixelwise binary strings (17x6 bytes)
                           2= single integers
                              (51 x MEDIUMINT or UNSIGNED SMALLINT)
                           3= single native string (106 bytes)
                           4= single native string (106 bytes) swapped
                         The sizes and types are valid for 16-bit coordinates
                       */
 char *sample_table;
 char id_fieldname[41];
 char adr_fieldname[41];
 char sample_fieldname[41];              /* appendize: [[_$color]_$pixno] */

 char *exempt_table;
 char eid_fieldname[41]; 
 char eboss_fieldname[41];
 char eadr_fieldname[41];
 char maxeid[81];      /* maximum value of eid_fieldname at most recent read */
 unsigned long *eid_list;
 unsigned long eid_count;
 unsigned long eid_readpos;

 MYSQL_RES *query_result;
 char *query_token;  /* a mark wether a query is open , catchable by smem */

 char *search_where;
 MYSQL_RES *search_result;
 char *search_token;
};


#endif /* ! Imgdbs_includeD */


/*

 ImgdbS represents the usage of a SQL database for purposes of the more general
 ImgdB . It currently has to store and retrieve records of type ImgsamplE
 and ImgexempT.

 This version uses the MySQL database server. Maybe one should divide ImgdbS
 into a generic SQL class and a database connection class which hides all
 specifics of MySQL.


 Database layout depending on the choosen sample format :

   CREATE TABLE $sample_table (
 all formats:
                $id_fieldname      BIGINT AUTO_INCREMENT NOT NULL,
                $adr_fieldname     TEXT,
 format 0:
                $sample_fieldname  TEXT,
 format 1:
                ${sample_fieldname}_0  TEXT,
                ...
                ${sample_fieldname}_15 TEXT,
 format 2:
                ${sample_fieldname}_red_0    MEDIUMINT,
                ${sample_fieldname}_green_0  MEDIUMINT,
                ${sample_fieldname}_blue_0   MEDIUMINT,
                ...
                ${sample_fieldname}_red_15   MEDIUMINT,
                ${sample_fieldname}_green_15 MEDIUMINT,
                ${sample_fieldname}_blue_15  MEDIUMINT,
 all formats:
                ${sample_fieldname}_red      MEDIUMINT,
                ${sample_fieldname}_green    MEDIUMINT,
                ${sample_fieldname}_blue     MEDIUMINT,
          INDEX ($id_fieldname))


   CREATE TABLE $exempt_table (
                $eid_fieldname     BIGINT AUTO_INCREMENT NOT NULL, 
                $eboss_fieldname   TINYINT,
                $eadr_fieldname    TEXT,
          INDEX ($eid_fieldname))



my session to create the first set of similar tables :

 mysql> CREATE DATABASE similar_db;
 mysql> \u similar_db
 mysql> CREATE TABLE similar_samples (
        id            BIGINT AUTO_INCREMENT NOT NULL,
        name          TEXT,
        smp17         TEXT,
        smp17_red     MEDIUMINT,
        smp17_green   MEDIUMINT,
        smp17_blue    MEDIUMINT,
        INDEX (id));
 mysql> CREATE TABLE similar_exempts  (
        eid           BIGINT AUTO_INCREMENT NOT NULL,
        eboss         TINYINT,
        ename         TEXT,
        INDEX (eid));
  

*/ 
