
#ifndef Imgsamp_includeD
#define Imgsamp_includeD


#define Imgsamp_max_sizE      16

typedef unsigned long         Imgsamp_crC;
typedef unsigned short        Imgsamp_coorD;
/* divide by this value to get coordinate in interval [0,256[ */
#define Imgsamp_scalE         256.0
#define Imgsample_max_coorD   0xffff

/* these invalid-flags may not be set on a valid sample */ 
#define Imgsamp_valid_requireD (1|2|8)
#define Imgsamp_invalid_coorD  8


struct ImgsamplE {

 int invalid;              /*
                              bit0= samp_adr
                              bit1= nam_adr
                              bit2= crc
                              bit3= coordinates
                            */
 unsigned long id;          /* 0= invalid */

 unsigned long samp_adr;
 unsigned long nam_adr;
 char *filename;
 int filename_is_reference;

 Imgsamp_crC crc;

 int spoints;                             /* actual number of sample points */

#ifdef Imgsample_pointer_layeR

 Imgsamp_coorD rgb[3*Imgsamp_max_sizE];
 Imgsamp_coorD *red,*green,*blue;

#else /* Imgsample_pointer_layeR */

 Imgsamp_coorD red[Imgsamp_max_sizE];
 Imgsamp_coorD green[Imgsamp_max_sizE];
 Imgsamp_coorD blue[Imgsamp_max_sizE];

#endif /* ! Imgsample_pointer_layeR */

 struct ImgsamplE *next,*prev;
};


double Imgsample_get_coord();


#endif /* ! Imgsamp_includeD */


/*
 ImgsamP represents an image file within a ImgmaP data base.
 On its own it mainly manages its RGB values while its other properties
 are controled by ImgmaP functions.

 functions:
  Imgsamp...
   _new()            create new sample object
   _set_rgb()        set number of sample points and their RGB values
   _copy()           copy sample data from one object to another
   _destroy()        destroy sample object
   __set_coord()     convert from double to Imgsamp_coorD
   _get_coord()      read color component of pixel as (double)
*/
