
/*
 cc -g -c similar.c
*/

#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <signal.h>


#include "../s_tools/sfile.h"

#include "../as/asagent.h"

#include "similar.h"



struct AsagenT *agent= NULL;

struct ImgcmP *icmp= NULL;

char cleanup_msg[81];


/* <<< Cleanup is grabbed out of a totally different project */
/*     it provides an outer shell to catch most signals */
/*     (that should be a neat part of the asagent classes) */


void Cleanup_handler_exit()
{
 int silent_end;
 char msg[161];

 alarm(0);
 silent_end= Asagent_get_silent_end(agent,0);
 if(! silent_end) {
   sprintf(msg,"\n\n%s\n\nProgram aborted\n\n",cleanup_msg);
   Asagent_stderr(agent,msg,1);
 }
 Imgcmp_destroy(&icmp,0);
 Asagent_destroy(&agent,0);
 if(! silent_end)
   exit(4);
 exit(0);
}


void Cleanup_handler_hup() 
{
 sprintf(cleanup_msg,"UNIX-SIGNAL:  SIGHUP   errno= %ld",errno); 
 Cleanup_handler_exit();
}
void Cleanup_handler_int() 
{
 sprintf(cleanup_msg,"UNIX-SIGNAL:  SIGINT   errno= %ld",errno); 
 Cleanup_handler_exit();
}
void Cleanup_handler_quit() 
{
 sprintf(cleanup_msg,"UNIX-SIGNAL:  SIGQUIT  errno= %ld",errno); 
 Cleanup_handler_exit();
}
void Cleanup_handler_ill() 
{
 sprintf(cleanup_msg,"UNIX-SIGNAL:  SIGILL   errno= %ld",errno); 
 Cleanup_handler_exit();
}
void Cleanup_handler_trap() 
{
 sprintf(cleanup_msg,"UNIX-SIGNAL:  SIGTRAP  errno= %ld",errno); 
 Cleanup_handler_exit();
}
void Cleanup_handler_emt() 
{
 sprintf(cleanup_msg,"UNIX-SIGNAL:  SIGEMT   errno= %ld",errno); 
 Cleanup_handler_exit();
}
void Cleanup_handler_fpe() 
{
 sprintf(cleanup_msg,"UNIX-SIGNAL:  SIGFPE   errno= %ld",errno); 
 Cleanup_handler_exit();
}
void Cleanup_handler_bus() 
{
 sprintf(cleanup_msg,"UNIX-SIGNAL:  SIGBUS   errno= %ld",errno); 
 Cleanup_handler_exit();
}
void Cleanup_handler_segv() 
{
 sprintf(cleanup_msg,"UNIX-SIGNAL:  SIGSEGV  errno= %ld",errno); 
 Cleanup_handler_exit();
}
void Cleanup_handler_sys() 
{
 sprintf(cleanup_msg,"UNIX-SIGNAL:  SIGSYS   errno= %ld",errno); 
 Cleanup_handler_exit();
}
void Cleanup_handler_pipe() 
{
 return;
}
void Cleanup_handler_urg() 
{
 return;
}

void Cleanup_handler_alrm()
{
 int silent_end;

 alarm(0);
 silent_end= Asagent_get_silent_end(agent,0);
 if(! silent_end)
   sprintf(cleanup_msg,"TIMEOUT !");
 Cleanup_handler_exit();
}

void Cleanup_handler_term() 
{
 sprintf(cleanup_msg,"UNIX-SIGNAL:  SIGTERM  errno= %ld",errno); 
 Cleanup_handler_exit();
}
void Cleanup_handler_xcpu() 
{
 sprintf(cleanup_msg,"UNIX-SIGNAL:  SIGXCPU  errno= %ld",errno); 
 Cleanup_handler_exit();
}
void Cleanup_handler_xfsz() 
{
 sprintf(cleanup_msg,"UNIX-SIGNAL:  SIGXFSZ  errno= %ld",errno); 
 Cleanup_handler_exit();
}
void Cleanup_handler_vtalrm() 
{
 sprintf(cleanup_msg,"UNIX-SIGNAL:  SIGVTALRM  errno= %ld",errno); 
 Cleanup_handler_exit();
}
void Cleanup_handler_prof() 
{
 sprintf(cleanup_msg,"UNIX-SIGNAL:  SIGPROF  errno= %ld",errno); 
 Cleanup_handler_exit();
}
void Cleanup_handler_usr1() 
{
 sprintf(cleanup_msg,"UNIX-SIGNAL:  SIGUSR1  errno= %ld",errno); 
 Cleanup_handler_exit();
}
void Cleanup_handler_usr2() 
{
 sprintf(cleanup_msg,"UNIX-SIGNAL:  SIGUSR2  errno= %ld",errno); 
 Cleanup_handler_exit();
}
void Cleanup_handler_addr() 
{
 sprintf(cleanup_msg,"UNIX-SIGNAL:  SIGADDR  errno= %ld",errno); 
 Cleanup_handler_exit();
}
void Cleanup_handler_zero() 
{
 sprintf(cleanup_msg,"UNIX-SIGNAL:  SIGZERO  errno= %ld",errno); 
 Cleanup_handler_exit();
}
void Cleanup_handler_chk() 
{
 sprintf(cleanup_msg,"UNIX-SIGNAL:  SIGCHK   errno= %ld",errno); 
 Cleanup_handler_exit();
}
void Cleanup_handler_over() 
{
 sprintf(cleanup_msg,"UNIX-SIGNAL:  SIGOVER  errno= %ld",errno); 
 Cleanup_handler_exit();
}
void Cleanup_handler_priv() 
{
 sprintf(cleanup_msg,"UNIX-SIGNAL:  SIGPRIV  errno= %ld",errno); 
 Cleanup_handler_exit();
}
void Cleanup_handler_pwr() 
{
 sprintf(cleanup_msg,"UNIX-SIGNAL:  SIGPWR   errno= %ld",errno); 
 Cleanup_handler_exit();
}
void Cleanup_handler_cld() 
{
 sprintf(cleanup_msg,"UNIX-SIGNAL:  SIGCLD   errno= %ld",errno); 
 Cleanup_handler_exit();
}
void Cleanup_handler_poll() 
{
 sprintf(cleanup_msg,"UNIX-SIGNAL:  SIGPOLL  errno= %ld",errno); 
 Cleanup_handler_exit();
}
void Cleanup_handler_abrt()
{
 sprintf(cleanup_msg,"UNIX-SIGNAL:  SIGABRT  errno= %ld",errno); 
 Cleanup_handler_exit();
}
void Cleanup_handler_tstp()
{
 sprintf(cleanup_msg,"UNIX-SIGNAL:  SIGTSTP  errno= %ld",errno); 
 Cleanup_handler_exit();
}
void Cleanup_handler_ttin()
{
 sprintf(cleanup_msg,"UNIX-SIGNAL:  SIGTTIN  errno= %ld",errno); 
 Cleanup_handler_exit();
}
void Cleanup_handler_ttou()
{
 sprintf(cleanup_msg,"UNIX-SIGNAL:  SIGTTOU  errno= %ld",errno); 
 Cleanup_handler_exit();
}
void Cleanup_handler_lost()
{
 sprintf(cleanup_msg,"UNIX-SIGNAL:  SIGLOST  errno= %ld",errno); 
 Cleanup_handler_exit();
}


int Cleanup_set_handlers(flag)
int flag;
/*
 bit0= set to default handlers
*/
{ 
 if(flag&1)
   goto set_default;

 cleanup_msg[0]= 0;
 signal(SIGHUP,Cleanup_handler_hup);
 signal(SIGINT,Cleanup_handler_int);
 signal(SIGQUIT,Cleanup_handler_quit);
 signal(SIGILL,Cleanup_handler_ill);
 signal(SIGTRAP,Cleanup_handler_trap);
 signal(SIGFPE,Cleanup_handler_fpe);
 signal(SIGBUS,Cleanup_handler_bus);
 signal(SIGSEGV,Cleanup_handler_segv);
 signal(SIGPIPE,Cleanup_handler_pipe);
 signal(SIGALRM,Cleanup_handler_alrm);
 signal(SIGTERM,Cleanup_handler_term);
 signal(SIGUSR1,Cleanup_handler_usr1);
 signal(SIGUSR2,Cleanup_handler_usr2);
 signal(SIGURG,Cleanup_handler_urg);
 signal(SIGXCPU,Cleanup_handler_xcpu);
 signal(SIGXFSZ,Cleanup_handler_xfsz);
 signal(SIGVTALRM,Cleanup_handler_vtalrm);
 signal(SIGPROF,Cleanup_handler_prof);
 return(1);
set_default:;
 signal(SIGHUP,SIG_DFL);
 signal(SIGINT,SIG_DFL);
 signal(SIGQUIT,SIG_DFL);
 signal(SIGILL,SIG_DFL);
 signal(SIGTRAP,SIG_DFL);
 signal(SIGFPE,SIG_DFL);
 signal(SIGBUS,SIG_DFL);
 signal(SIGSEGV,SIG_DFL);
 signal(SIGPIPE,SIG_DFL);
 signal(SIGALRM,SIG_DFL);
 signal(SIGTERM,SIG_DFL);
 signal(SIGUSR1,SIG_DFL);
 signal(SIGUSR2,SIG_DFL);
 signal(SIGURG,SIG_DFL);
 signal(SIGXCPU,SIG_DFL);
 signal(SIGXFSZ,SIG_DFL);
 signal(SIGVTALRM,SIG_DFL);
 signal(SIGPROF,SIG_DFL);
 return(1);
}


main(argc,argv)
int argc;
char **argv;
{
 int ret,ard= 1, help_only= 0,no_rc=0,just_a_client= 0;
 static char *end_cmd= "-end";
 char mapname[SfileadrL];
 int Imgcmp_interpreter();

 char *cpt;
 int j,i;

 /* <<< preliminary signal handling */
 Cleanup_set_handlers(0);

 /* full memory supervision */
 Smem_set_record_items(1);

 if(argc==2)
   if(strcmp(argv[1],"-help")==0)
     help_only= 1;
 if(argc>=2)
   if(strcmp(argv[1],"-no_rc")==0)
     no_rc= 1;

 ret= Asagent_new(&agent,argv[0],1,0);
 if(ret<=0) {
agent_failed:;
   fprintf(stderr,"%s : creation of agent object failed\n",argv[0]);

   fprintf(stderr,"   agent=%8.8x   icmp=%8.8x\n",agent,icmp);
   exit(1);

   /* ??? does this cause my system to get stuck ? */
   ret= 1; goto ex;
 }
 Asagent_set_silent_end(agent,1,0);

 /* memory usage messages each 0(=deactivated) commands */
 agent->smem_stderr= 0;


 Sfile_home_adr(Similar_default_mapnamE,mapname,0);
 ret= Imgcmp_new(&icmp,agent,mapname,0);
 if(ret<=0) {
   fprintf(stderr,"%s : creation of comparer object failed\n",argv[0]);
   ret= 1; goto ex;
 }
 /* Overload only the command interpreter */
 Asagent_attach_app(agent,icmp,Imgcmp_interpreter,NULL,NULL,NULL,NULL,NULL,0);

 if(!(help_only||no_rc)){
   ret= Imgcmp_rc(icmp,0);
   if(ret<0) {
     ret= 5; goto ex;
   } else if(ret==3)
     goto ok;
 }
 ard= 1+no_rc;
 ret= Asagent_read_options(agent,argc,argv,&ard,0);
 if(ret<=0) {
   ret= 2; goto ex;
 } else if(ret==3 || help_only)
   goto ok;

 /* if there are no external input channels and nothing in the queue :
    execute -end command
    (cannot end immediately because the loop eventually waits for server reply)
  */
 if(Asagent_count_services(agent,0)<=0 &&
    ! Asagent_event_is_pending(agent,1)) {
   just_a_client= 1;
   Asagent_set_server_crucial(agent,1);  /* exit if server connection fails */
   Asagent_cmd_internal(agent,"termios:off",0);
   Asagent_set_arguments_to_queue(agent,1,0);
   ard= 0;
   ret= Asagent_read_options(agent,1,&end_cmd,&ard,0);
   if(ret<=0)
     { ret= 2; goto ex; }
 }

 ret= Asagent_loop(agent,1);
 if(ret<=0) {
   fprintf(stderr,"%s : event loop aborted\n",argv[0]);
   ret= 3; goto ex;
 }
 if(ret==3)
   goto ok;

ok:;
 ret= 0;
ex:
 Imgcmp_destroy(&icmp,0);
 Asagent_destroy(&agent,0);
 if(!just_a_client)
   Smem_stderr(1|2);
 exit(ret);
}

