
#include "../s_tools/sfile.h"
#include "nntppost.h"

#define Nntpclient_strmaX 1024

struct NntpclienT {

 /* Name of the program which is using nntpclient */
 char progname[Nntpclient_strmaX];
 char start_dir[SfileadrL];

 /* Server */
 char servername[Nntpclient_strmaX];
 int port;
 struct NntpconN *conn;
 int timeout;
 int timeout_bell;  /* 1= print ASCII 7 on timeout */
 double r_baudlimit;
 int use_nov;     /* 0= no , 1= yes, 
                     2= if nntpclient_use_xover is in server's directory */
 struct NntpnoV *nov;
 int request_head_on_group;
 int show_pacifiers;              /* wether to show i/o statistics on stderr */

 /* User */
 char login[Nntpclient_strmaX];
 char password[Nntpclient_strmaX];

 /* Group */
 struct NntpgrouP *group;
 struct NntpstatS *stats;

 /* Message */
 struct NntpheaD *head;
 struct NntploaD *loadjob;

 /* Target */
 char basedir[SfileadrL];
 char download_dir[SfileadrL];
 int overwrite;
 int html;              /* generate HTML tags within messages and lists */
 int short_form;        /* 0= write everything but binary data to the msg file
                           1= only a few header lines, no pre-MIME messages
                              no MIME boundaries */
 int list_on_stdout;    /* 0= do not print list result lines to stdout */

 /* housekeeping */
 struct NntpfileR *filer;

 /* Filter */
 struct NntpfilteR *filter;

 /* Posting */
 int use_own_msgid;
 char hostid[Nntppost_stringleN];
 char username[Nntppost_stringleN];
 char organization[Nntppost_stringleN];
 char reference[Nntppost_stringleN];
 int posting_style;  /* bit0-3= mode:
                         0= flat:   refer to references[]
                         1= indent: refer following messages to first one
                         2= stair:  refer following messages to previous one
                     */
 
 /* output */
 char user_messages[SfileadrL];

 /* Job */
 int argc;
 char **argv;
 int argidx;

 /* Handling ill servers */
 int check_for_short_article;
 int short_article_counter;
 int short_article_maxtry;
 int check_for_slow_server;
 double slow_server_minsize;
 double slow_server_limit;

};


#define Nntpclient_basediR "snntpbatch_download"

#define Nntpclient_lock_waiT 500000
#define Nntpclient_mntc_namE "maintenance_lock"

#define Nntpclient_max_list_itemS 500

#define Nntpclient_xover_chunksizE 100

