
#define Nntpfilter_V2 1

#define Nntpfilter_strL 1024


/*
   A single Testnode .
   True if all re-components are true or NULL
*/
struct NntpftesT {

 int invert;  /* 0=normal  1=invert result */ 

 /* Message Header */
 char from[Nntpfilter_strL];
 struct SregeX *re_from;
 char date[Nntpfilter_strL];
 struct SregeX *re_date;
 char subject[Nntpfilter_strL];
 struct SregeX *re_subject;

 /* File Name */
 int filetest_type;           /*
                                0=filename pattern (filename:), 
                                1=filename pattern (subjectfile:)
                                2=directory list (subjectfilefound:)
                                3=hash into directory (subjectfilerec:)
                              */
 char filename[4*4096];
 struct SregeX *re_filename;
 
 /* external handle to collect information about subjectfilerec: */
 char **sfrec_dirlistpt;
 char **sfrec_namept;
};


/* 
   A computational node.
   A tree of these nodes forms the filter criterion.
   Sequences of AND/OR operations form branches, brackets spawn new branches,
   NOT inverts node's test resp. subtree result.
*/
struct NntpfnodE {

 struct NntpfnodE *up;

  /* Operators */
 int invert;  /* 0=normal  1=invert own result (subtree or test, but not op) */ 

 int assoc; /*
                0= left : compute own value, combine with left value,
                          compute right value, combine with current value
                1= right: compute own value, compute right value, 
                          combine own and right, combine with left value
             */
 int use_shortcuts;

 struct NntpfnodE *left;
 int left_op; /* 0=OR , 1=AND */
  
 struct NntpfnodE *right;
 int right_op; /* see left_op */

 /* Brackets : a pointer to the first node in a subchain */ 
 struct NntpfnodE *sub; 

 /* if sub!=NULL , test is ignored */
 struct NntpftesT *test;

 /* Result */
 int own_value;
 int composed_value;

};


/*
 A Filter
*/
struct NntpfilteR {

 /* Message Id */
 int msgno_start;
 int msgno_end;
 int msgno_idx;
 int msgno_prev[2];

 /* Tree of tests */
 struct NntpfnodE *root;

 struct NntpfnodE *cursor;
 int invert;  /* 0=normal  1=set invert-property for next new fnode */ 
 int use_shortcuts;

 /* memorize subjectfilerec: in case an error occurs while loading */
 char *sfrec_dirlist;
 char *sfrec_name;
 int sfrec_name_loaded;

 /* Errors */
 char errmsg[4096];
 int errn; /*
             >0 = UNIX errno
             -1 = close_bracket: no bracket open 
             -2 = binary operator or closing bracket expected
             -3 = unexpected binary operator or closing bracket
           */
 
};


