
#include "../s_tools/sfile.h"

#ifndef Nntpload_head_inludeD

struct NntploaD {

 /* boss */
 struct NntpclienT *boss;

 /* source */
 struct NntpconN *conn;
 int article_state; /* 0=unread , 1=HEAD , 2=BODY */

 struct NntpheaD *head;
 int head_extern;
 struct NntpsubheaD *subhead;
 int subhead_extern;
 int header_seen;
 double announced_size;

 /* Encoding */
 int encoding; /*  -1=unencoded
                    0=still undetermined
                    1= MIME 1.0
                       "Content-Type: multipart/mixed; boundary=..."
                       && "Content-Transfer-Encoding: base64"
                    2= uuencode
                       "begin [0-7][0-7][0-7] filename ... end"
                    3= enforce plain text coding
                */
 int bin_tee; /*
                   -1= no tee with undecoded binary data
                    0= no decision up to now
                    1= watch out for beginning of binary data
                    2= tee complete message body
               */
 int html;               /* generate HTML tags within messages and lists */
 int short_header;

 /* Externally attached filter for content oriented selection */
 struct NntpfilteR *filter;

 /* target */
 char dir[SfileadrL];
 int filename_auto;      /* generate message filename from message number */
 char filename[SfileadrL];
 mode_t bin_chmod;
 int  bin_count;
 char bin_name[SfileadrL];
 char tee_name[SfileadrL];
 FILE *tee_fp;

 /* >>> this is not working yet. multi_binary just triggers teeing */
 /* multipart binary files */
 int multi_binary;       /* 0= disabled , 1= enabled ,
                                          2= enabled for two digit pattern */
 int bin_parts;
 int current_bin_part;
};


/* These are formatters for sprintf(,,filename) . Use exactly one %s .*/
/* The result has to be a valid shell command expecting the coded data at
   standard input and writing the decoded results to filename . */

#define Nntpload_mime_decodeR      "mimencode -u > %s"
#define Nntpload_uuencode_decodeR  "uudecode -o %s"

/* subdirectory of message directory for storing binary files */
#define Nntpload_bindiR            "bin"

/* quite restrictive default, just in case the second umask() does not work */
#define Nntpload_access_rightS  (S_IRUSR|S_IWUSR)


#define Nntpload_head_inludeD YES

#endif /* ! Nntpload_head_inludeD */

