
#ifndef Sblowfish_includeD
#define Sblowfish_includeD


#ifndef ORDER_ABCD
#ifndef ORDER_DCBA
#ifndef ORDER_BADC
/* default is Linux on AMD/Intel */ 
#define ORDER_DCBA
#endif
#endif
#endif


/*********************blowfish.h********************/

/* derived from: $Id: blowfish.h,v 1.3 1995/01/23 12:38:02 pr Exp pr $*/

#define MAXKEYBYTES 56          /* 448 bits */
#define bf_N             16
#define noErr            0
#define DATAERROR         -1
#define KEYBYTES         8


#define UWORD_32bits  unsigned long
#define UWORD_16bits  unsigned short
#define UBYTE_08bits  unsigned char

/* choose a byte order for your hardware */
/* ABCD - big endian - motorola */
#ifdef ORDER_ABCD
union aword {
  UWORD_32bits word;
  UBYTE_08bits byte [4];
  struct {
    unsigned int byte0:8;
    unsigned int byte1:8;
    unsigned int byte2:8;
    unsigned int byte3:8;
  } w;
};
#endif  /* ORDER_ABCD */

/* DCBA - little endian - intel */
#ifdef ORDER_DCBA
union aword {
  UWORD_32bits word;
  UBYTE_08bits byte [4];
  struct {
    unsigned int byte3:8;
    unsigned int byte2:8;
    unsigned int byte1:8;
    unsigned int byte0:8;
  } w;
};
#endif  /* ORDER_DCBA */

/* BADC - vax */
#ifdef ORDER_BADC
union aword {
  UWORD_32bits word;
  UBYTE_08bits byte [4];
  struct {
    unsigned int byte1:8;
    unsigned int byte0:8;
    unsigned int byte3:8;
    unsigned int byte2:8;
  } w;
};
#endif  /* ORDER_BADC */


typedef UWORD_32bits Blowfish_spT[256];




struct SblowfisH {
  UWORD_32bits bf_P[bf_N + 2];
  UWORD_32bits bf_S[4][256];

  unsigned char last_inblock[8];
  unsigned char last_outblock[8];
};


/* make a binary key of fixed length from a text key with abritrary length */
char *Sblowfish_make_key();


#endif /* ! Sblowfish_includeD */

